import os
import json

#
#
#
from .system import System
from .path   import DaemonPath

#
# this is the build of the Web UI
#
class Build:

    @staticmethod
    def version():

        if System.WS_WINDOWS == System.name():
            return "0.0.0.0"

        return "7.6.0.5D82"


#
# this is the build of the Web Safety Core
#
class CoreBuild:

    @staticmethod
    def version():

        try:
            with open(os.path.join(DaemonPath.etc_dir(), "version.json")) as fin:
                data = json.load(fin)               

            v = data.get("version", "0.0.0.0")
            if v == "7.6.0.5D82":
                raise Exception("Sources are not build yet, ignoring version")

            return v
                
        except Exception as e:
            return "0.0.0.0"