import os
import platform

#
# constant predefined paths for the daemon folder
#
class DaemonPath:

    @staticmethod
    def install_dir():

        if platform.system() == "Windows":
            return "m:\\websafety-core\\src.res\\opt\\websafety"

        return "/opt/websafety"

    @staticmethod
    def bin_dir():
        return os.path.join(DaemonPath.install_dir(), "bin")

    @staticmethod
    def etc_dir():
        return os.path.join(DaemonPath.install_dir(), "etc")

    @staticmethod
    def var_dir():
        return os.path.join(DaemonPath.install_dir(), "var")

#
# constant predefined paths for the UI folder
#
class UiPath:

    @staticmethod
    def install_dir():

        if platform.system() == "Windows":
            return "m:\\websafety-ui\\src.res\\opt\\websafety-ui"

        return "/opt/websafety-ui"

    @staticmethod
    def bin_dir():
        return os.path.join(UiPath.install_dir(), "bin")

    @staticmethod
    def etc_dir():
        return os.path.join(UiPath.install_dir(), "etc")

    @staticmethod
    def var_dir():
        return os.path.join(UiPath.install_dir(), "var")


#
# constant predefined name of the user for the UI 
#
class UiUser:

    @staticmethod
    def name():
        return "websafety"