from .system  import System
from .distrib import Distrib

#
# constant predefined paths for squid
#
class SquidPath:
    
    @staticmethod
    def log_dir():

        name = System.name()

        if System.WS_LINUX == name:
            return "/var/log/squid"
        elif System.WS_WINDOWS == name:
            return "m:\\websafety-ui\\tools\\var\\log\\squid"
        else:
            raise Exception("Cannot determine location of Squid logs for system '%s'" % name)

#
#
#
class SquidUser:

    @staticmethod
    def name():

        dist = Distrib.name()

        if dist in [Distrib.WS_UBUNTU20, Distrib.WS_DEBIAN11]:
            return "proxy"
        if dist in [Distrib.WS_REDHAT8]:
            return "squid"
        if dist in [Distrib.WS_WINDOWSX]:
            return "not_impl_on_windows"

        raise Exception("Cannot determine Squid process name for distrib '%s'" % dist)
