import os

#
#
#
#from _domain.core import Paths, DnsSafetyPaths, System
#from _domain.utils import Command

#
#
#
class DomainCategorizer:

    def categorize(self, domain):
    
        try:
            name = "categories_checker"
            if System.WS_WINDOWS == System.name():
                name += ".exe"

            exe  = os.path.join(DnsSafetyPaths.bin_dir(), name)
            arg1 = "--definitions=%s" % (os.path.join(DnsSafetyPaths.var_dir(), "spool", "categories", "definitions.dat"))
            arg2 = "--domain=%s" % domain

            (exit_code, stdout, stderr) = Command().run([exe, arg1, arg2]) 
            
            if 0 == exit_code:
                data = stdout.strip()
                data = data.strip("]")
                data = data.strip("[")
                data = data.strip()
                if len(data) == 0:
                    return []
                else:
                    return data.split(':')
                    
        except Exception as e:
            pass
        
        return []


#
# bit masks for categories - generated by M:\defs.diladele.com\db_definitions\updates\code.py
#
class BuildInCategories:

    # numeric categories
    CATEGORY_NONE                           = 0
    CATEGORY_ADULT_THEMES_SEXUALITY         = 1 << 1
    CATEGORY_ADVERTISING                    = 1 << 2
    CATEGORY_ALCOHOL_TOBACCO                = 1 << 3
    CATEGORY_ANIME_MANGA_WEBCOMIC           = 1 << 4
    CATEGORY_ARTS_SOCIETY_CULTURE           = 1 << 5
    CATEGORY_AUTOMOTIVE                     = 1 << 6
    CATEGORY_BANKING_INSURANCE_FINANCE      = 1 << 7
    CATEGORY_BLOGS_PERSONAL                 = 1 << 8
    CATEGORY_BUSINESS_SERVICES_INDUSTRY     = 1 << 9
    CATEGORY_CLASSIFIEDS_AUCTIONS           = 1 << 10
    CATEGORY_CONTENT_DELIVERY_NETWORKS      = 1 << 11
    CATEGORY_CRACKS_HACKING_ILLEGAL         = 1 << 12
    CATEGORY_DATING                         = 1 << 13
    CATEGORY_DRUGS                          = 1 << 14
    CATEGORY_ECOMMERCE_SHOPPING             = 1 << 15
    CATEGORY_EDUCATION_SCIENCE_RESEARCH     = 1 << 16
    CATEGORY_ENTERTAINMENT_HUMOR_HOBBY      = 1 << 17
    CATEGORY_EXPIRED_PARKED                 = 1 << 18
    CATEGORY_FASHION_BEAUTY_COSMETICS       = 1 << 19
    CATEGORY_FILE_STORAGE                   = 1 << 20
    CATEGORY_FOOD_DINING_RESTAURANTS        = 1 << 21
    CATEGORY_FORUMS_MESSAGE_BOARDS          = 1 << 22
    CATEGORY_GAMBLING                       = 1 << 23
    CATEGORY_GAMES                          = 1 << 24
    CATEGORY_GENERIC_NON_CATEGORIZED        = 1 << 25
    CATEGORY_GOVERNMENT                     = 1 << 26
    CATEGORY_HATE_DISCRIMINATION_VIOLENCE   = 1 << 27
    CATEGORY_HEALTH_MEDICINE_FITNESS        = 1 << 28
    CATEGORY_JOBS_EMPLOYMENT_CAREER         = 1 << 29
    CATEGORY_MESSAGING_CHAT                 = 1 << 30
    CATEGORY_MOVIES                         = 1 << 31
    CATEGORY_MUSIC_RADIO                    = 1 << 32
    CATEGORY_NETWORK_INFRASTRUCTURE         = 1 << 33
    CATEGORY_NEWS_MEDIA                     = 1 << 34
    CATEGORY_NUDITY_PORNOGRAPHY             = 1 << 35
    CATEGORY_P2P_FILE_SHARING               = 1 << 36
    CATEGORY_PHOTO_SHARING                  = 1 << 37
    CATEGORY_POLITICS                       = 1 << 38
    CATEGORY_PORTALS                        = 1 << 39
    CATEGORY_PROXY_ANONYMIZER               = 1 << 40
    CATEGORY_REAL_ESTATE_HOME_INTERIOR      = 1 << 41
    CATEGORY_RELIGIOUS                      = 1 << 42
    CATEGORY_SEARCH_ENGINES                 = 1 << 43
    CATEGORY_SELF_HARM                      = 1 << 44
    CATEGORY_SOCIAL_NETWORKING              = 1 << 45
    CATEGORY_SOFTWARE_TECHNOLOGY_HARDWARE   = 1 << 46
    CATEGORY_SPORTS                         = 1 << 47
    CATEGORY_TELEVISION                     = 1 << 48
    CATEGORY_TRAVEL                         = 1 << 49
    CATEGORY_USER_TRACKING                  = 1 << 50
    CATEGORY_VIDEO_SHARING                  = 1 << 51
    CATEGORY_WEAPONS                        = 1 << 52
    CATEGORY_WEBMAIL                        = 1 << 53
    CATEGORY_MAXIMUM                        = 1 << 54

    # list of available categories as array
    CATEGORY_NAMES = [
        "adult_themes_sexuality",
        "advertising",
        "alcohol_tobacco",
        "anime_manga_webcomic",
        "arts_society_culture",
        "automotive",
        "banking_insurance_finance",
        "blogs_personal",
        "business_services_industry",
        "classifieds_auctions",
        "content_delivery_networks",
        "cracks_hacking_illegal",
        "dating",
        "drugs",
        "ecommerce_shopping",
        "education_science_research",
        "entertainment_humor_hobby",
        "expired_parked",
        "fashion_beauty_cosmetics",
        "file_storage",
        "food_dining_restaurants",
        "forums_message_boards",
        "gambling",
        "games",
        "generic_non_categorized",
        "government",
        "hate_discrimination_violence",
        "health_medicine_fitness",
        "jobs_employment_career",
        "messaging_chat",
        "movies",
        "music_radio",
        "network_infrastructure",
        "news_media",
        "nudity_pornography",
        "p2p_file_sharing",
        "photo_sharing",
        "politics",
        "portals",
        "proxy_anonymizer",
        "real_estate_home_interior",
        "religious",
        "search_engines",
        "self_harm",
        "social_networking",
        "software_technology_hardware",
        "sports",
        "television",
        "travel",
        "user_tracking",
        "video_sharing",
        "weapons",
        "webmail",
    ]

    @staticmethod
    def map_name(name):

        name_lower = name.lower()
        if name_lower == "adult_themes_sexuality":
            return BuildInCategories.CATEGORY_ADULT_THEMES_SEXUALITY;

        if name_lower == "advertising":
            return BuildInCategories.CATEGORY_ADVERTISING;

        if name_lower == "alcohol_tobacco":
            return BuildInCategories.CATEGORY_ALCOHOL_TOBACCO;

        if name_lower == "anime_manga_webcomic":
            return BuildInCategories.CATEGORY_ANIME_MANGA_WEBCOMIC;

        if name_lower == "arts_society_culture":
            return BuildInCategories.CATEGORY_ARTS_SOCIETY_CULTURE;

        if name_lower == "automotive":
            return BuildInCategories.CATEGORY_AUTOMOTIVE;

        if name_lower == "banking_insurance_finance":
            return BuildInCategories.CATEGORY_BANKING_INSURANCE_FINANCE;

        if name_lower == "blogs_personal":
            return BuildInCategories.CATEGORY_BLOGS_PERSONAL;

        if name_lower == "business_services_industry":
            return BuildInCategories.CATEGORY_BUSINESS_SERVICES_INDUSTRY;

        if name_lower == "classifieds_auctions":
            return BuildInCategories.CATEGORY_CLASSIFIEDS_AUCTIONS;

        if name_lower == "content_delivery_networks":
            return BuildInCategories.CATEGORY_CONTENT_DELIVERY_NETWORKS;

        if name_lower == "cracks_hacking_illegal":
            return BuildInCategories.CATEGORY_CRACKS_HACKING_ILLEGAL;

        if name_lower == "dating":
            return BuildInCategories.CATEGORY_DATING;

        if name_lower == "drugs":
            return BuildInCategories.CATEGORY_DRUGS;

        if name_lower == "ecommerce_shopping":
            return BuildInCategories.CATEGORY_ECOMMERCE_SHOPPING;

        if name_lower == "education_science_research":
            return BuildInCategories.CATEGORY_EDUCATION_SCIENCE_RESEARCH;

        if name_lower == "entertainment_humor_hobby":
            return BuildInCategories.CATEGORY_ENTERTAINMENT_HUMOR_HOBBY;

        if name_lower == "expired_parked":
            return BuildInCategories.CATEGORY_EXPIRED_PARKED;

        if name_lower == "fashion_beauty_cosmetics":
            return BuildInCategories.CATEGORY_FASHION_BEAUTY_COSMETICS;

        if name_lower == "file_storage":
            return BuildInCategories.CATEGORY_FILE_STORAGE;

        if name_lower == "food_dining_restaurants":
            return BuildInCategories.CATEGORY_FOOD_DINING_RESTAURANTS;

        if name_lower == "forums_message_boards":
            return BuildInCategories.CATEGORY_FORUMS_MESSAGE_BOARDS;

        if name_lower == "gambling":
            return BuildInCategories.CATEGORY_GAMBLING;

        if name_lower == "games":
            return BuildInCategories.CATEGORY_GAMES;

        if name_lower == "generic_non_categorized":
            return BuildInCategories.CATEGORY_GENERIC_NON_CATEGORIZED;

        if name_lower == "government":
            return BuildInCategories.CATEGORY_GOVERNMENT;

        if name_lower == "hate_discrimination_violence":
            return BuildInCategories.CATEGORY_HATE_DISCRIMINATION_VIOLENCE;

        if name_lower == "health_medicine_fitness":
            return BuildInCategories.CATEGORY_HEALTH_MEDICINE_FITNESS;

        if name_lower == "jobs_employment_career":
            return BuildInCategories.CATEGORY_JOBS_EMPLOYMENT_CAREER;

        if name_lower == "messaging_chat":
            return BuildInCategories.CATEGORY_MESSAGING_CHAT;

        if name_lower == "movies":
            return BuildInCategories.CATEGORY_MOVIES;

        if name_lower == "music_radio":
            return BuildInCategories.CATEGORY_MUSIC_RADIO;

        if name_lower == "network_infrastructure":
            return BuildInCategories.CATEGORY_NETWORK_INFRASTRUCTURE;

        if name_lower == "news_media":
            return BuildInCategories.CATEGORY_NEWS_MEDIA;

        if name_lower == "nudity_pornography":
            return BuildInCategories.CATEGORY_NUDITY_PORNOGRAPHY;

        if name_lower == "p2p_file_sharing":
            return BuildInCategories.CATEGORY_P2P_FILE_SHARING;

        if name_lower == "photo_sharing":
            return BuildInCategories.CATEGORY_PHOTO_SHARING;

        if name_lower == "politics":
            return BuildInCategories.CATEGORY_POLITICS;

        if name_lower == "portals":
            return BuildInCategories.CATEGORY_PORTALS;

        if name_lower == "proxy_anonymizer":
            return BuildInCategories.CATEGORY_PROXY_ANONYMIZER;

        if name_lower == "real_estate_home_interior":
            return BuildInCategories.CATEGORY_REAL_ESTATE_HOME_INTERIOR;

        if name_lower == "religious":
            return BuildInCategories.CATEGORY_RELIGIOUS;

        if name_lower == "search_engines":
            return BuildInCategories.CATEGORY_SEARCH_ENGINES;

        if name_lower == "self_harm":
            return BuildInCategories.CATEGORY_SELF_HARM;

        if name_lower == "social_networking":
            return BuildInCategories.CATEGORY_SOCIAL_NETWORKING;

        if name_lower == "software_technology_hardware":
            return BuildInCategories.CATEGORY_SOFTWARE_TECHNOLOGY_HARDWARE;

        if name_lower == "sports":
            return BuildInCategories.CATEGORY_SPORTS;

        if name_lower == "television":
            return BuildInCategories.CATEGORY_TELEVISION;

        if name_lower == "travel":
            return BuildInCategories.CATEGORY_TRAVEL;

        if name_lower == "user_tracking":
            return BuildInCategories.CATEGORY_USER_TRACKING;

        if name_lower == "video_sharing":
            return BuildInCategories.CATEGORY_VIDEO_SHARING;

        if name_lower == "weapons":
            return BuildInCategories.CATEGORY_WEAPONS;

        if name_lower == "webmail":
            return BuildInCategories.CATEGORY_WEBMAIL;

        return BuildInCategories.CATEGORY_NONE

    @staticmethod
    def unmap_name(v):

        result = []

        # optimization
        if v == 0:
            return result
            
        if v & BuildInCategories.CATEGORY_ADULT_THEMES_SEXUALITY:
            result.append("adult_themes_sexuality")

        if v & BuildInCategories.CATEGORY_ADVERTISING:
            result.append("advertising")

        if v & BuildInCategories.CATEGORY_ALCOHOL_TOBACCO:
            result.append("alcohol_tobacco")

        if v & BuildInCategories.CATEGORY_ANIME_MANGA_WEBCOMIC:
            result.append("anime_manga_webcomic")

        if v & BuildInCategories.CATEGORY_ARTS_SOCIETY_CULTURE:
            result.append("arts_society_culture")

        if v & BuildInCategories.CATEGORY_AUTOMOTIVE:
            result.append("automotive")

        if v & BuildInCategories.CATEGORY_BANKING_INSURANCE_FINANCE:
            result.append("banking_insurance_finance")

        if v & BuildInCategories.CATEGORY_BLOGS_PERSONAL:
            result.append("blogs_personal")

        if v & BuildInCategories.CATEGORY_BUSINESS_SERVICES_INDUSTRY:
            result.append("business_services_industry")

        if v & BuildInCategories.CATEGORY_CLASSIFIEDS_AUCTIONS:
            result.append("classifieds_auctions")

        if v & BuildInCategories.CATEGORY_CONTENT_DELIVERY_NETWORKS:
            result.append("content_delivery_networks")

        if v & BuildInCategories.CATEGORY_CRACKS_HACKING_ILLEGAL:
            result.append("cracks_hacking_illegal")

        if v & BuildInCategories.CATEGORY_DATING:
            result.append("dating")

        if v & BuildInCategories.CATEGORY_DRUGS:
            result.append("drugs")

        if v & BuildInCategories.CATEGORY_ECOMMERCE_SHOPPING:
            result.append("ecommerce_shopping")

        if v & BuildInCategories.CATEGORY_EDUCATION_SCIENCE_RESEARCH:
            result.append("education_science_research")

        if v & BuildInCategories.CATEGORY_ENTERTAINMENT_HUMOR_HOBBY:
            result.append("entertainment_humor_hobby")

        if v & BuildInCategories.CATEGORY_EXPIRED_PARKED:
            result.append("expired_parked")

        if v & BuildInCategories.CATEGORY_FASHION_BEAUTY_COSMETICS:
            result.append("fashion_beauty_cosmetics")

        if v & BuildInCategories.CATEGORY_FILE_STORAGE:
            result.append("file_storage")

        if v & BuildInCategories.CATEGORY_FOOD_DINING_RESTAURANTS:
            result.append("food_dining_restaurants")

        if v & BuildInCategories.CATEGORY_FORUMS_MESSAGE_BOARDS:
            result.append("forums_message_boards")

        if v & BuildInCategories.CATEGORY_GAMBLING:
            result.append("gambling")

        if v & BuildInCategories.CATEGORY_GAMES:
            result.append("games")

        if v & BuildInCategories.CATEGORY_GENERIC_NON_CATEGORIZED:
            result.append("generic_non_categorized")

        if v & BuildInCategories.CATEGORY_GOVERNMENT:
            result.append("government")

        if v & BuildInCategories.CATEGORY_HATE_DISCRIMINATION_VIOLENCE:
            result.append("hate_discrimination_violence")

        if v & BuildInCategories.CATEGORY_HEALTH_MEDICINE_FITNESS:
            result.append("health_medicine_fitness")

        if v & BuildInCategories.CATEGORY_JOBS_EMPLOYMENT_CAREER:
            result.append("jobs_employment_career")

        if v & BuildInCategories.CATEGORY_MESSAGING_CHAT:
            result.append("messaging_chat")

        if v & BuildInCategories.CATEGORY_MOVIES:
            result.append("movies")

        if v & BuildInCategories.CATEGORY_MUSIC_RADIO:
            result.append("music_radio")

        if v & BuildInCategories.CATEGORY_NETWORK_INFRASTRUCTURE:
            result.append("network_infrastructure")

        if v & BuildInCategories.CATEGORY_NEWS_MEDIA:
            result.append("news_media")

        if v & BuildInCategories.CATEGORY_NUDITY_PORNOGRAPHY:
            result.append("nudity_pornography")

        if v & BuildInCategories.CATEGORY_P2P_FILE_SHARING:
            result.append("p2p_file_sharing")

        if v & BuildInCategories.CATEGORY_PHOTO_SHARING:
            result.append("photo_sharing")

        if v & BuildInCategories.CATEGORY_POLITICS:
            result.append("politics")

        if v & BuildInCategories.CATEGORY_PORTALS:
            result.append("portals")

        if v & BuildInCategories.CATEGORY_PROXY_ANONYMIZER:
            result.append("proxy_anonymizer")

        if v & BuildInCategories.CATEGORY_REAL_ESTATE_HOME_INTERIOR:
            result.append("real_estate_home_interior")

        if v & BuildInCategories.CATEGORY_RELIGIOUS:
            result.append("religious")

        if v & BuildInCategories.CATEGORY_SEARCH_ENGINES:
            result.append("search_engines")

        if v & BuildInCategories.CATEGORY_SELF_HARM:
            result.append("self_harm")

        if v & BuildInCategories.CATEGORY_SOCIAL_NETWORKING:
            result.append("social_networking")

        if v & BuildInCategories.CATEGORY_SOFTWARE_TECHNOLOGY_HARDWARE:
            result.append("software_technology_hardware")

        if v & BuildInCategories.CATEGORY_SPORTS:
            result.append("sports")

        if v & BuildInCategories.CATEGORY_TELEVISION:
            result.append("television")

        if v & BuildInCategories.CATEGORY_TRAVEL:
            result.append("travel")

        if v & BuildInCategories.CATEGORY_USER_TRACKING:
            result.append("user_tracking")

        if v & BuildInCategories.CATEGORY_VIDEO_SHARING:
            result.append("video_sharing")

        if v & BuildInCategories.CATEGORY_WEAPONS:
            result.append("weapons")

        if v & BuildInCategories.CATEGORY_WEBMAIL:
            result.append("webmail")

        return result


#
# used in pandas reports - convert categories flags as int to array of strings
#
def categories_to_strings(categories_as_flags):

   # just reuse
   return ", ".join(
      BuildInCategories.unmap_name(
         categories_as_flags
      )
   )

