import gzip

#
# reads a given file line by line
#
class Reader:

    def __init__(self, file):

        # save the file
        self.file = file

        # and open it
        if file.endswith(".gz") or file.endswith(".gzip"):
            self.fin = gzip.open(file, mode="rt", errors="replace")
        else:
            self.fin = open(file, mode="rt", errors="replace")

        # set the line count
        self.counter = 0

    def __del__(self):

        # close the file
        self.fin.close()

    def getline(self):

        # read the line
        line = self.fin.readline()

        # increase the counter
        self.counter += 1

        # debug check the line is a string - just because we open both gz and normal files as strings
        assert(isinstance(line, str))

        # and return normally
        return line

        # if it is a string return right away
        #if isinstance(line, str):
        #    return line

        # if it is a byte array try to decode (as case in gzipped file)
        #if isinstance(line, bytes):
        #    return line.decode("utf-8", errors='ignore')

        # otherwise throw
        raise Exception("Cannot get either string or bytes from '%s'" % self.file)
