import os

#
#
#
from .writer import Writer

#
#
#
class Writers:

    def __init__(self, out_dir):

        # debug just in case
        assert(os.path.isdir(out_dir))

        # empty dict of writers and out dir
        self.writers = {}
        self.out_dir = out_dir

    def append(self, entry):

        # if no such writer, allocate it
        if entry.date not in self.writers:
            self.writers[entry.date] = Writer(self.out_dir, entry.date)

        # get the writer
        writer = self.writers[entry.date]

        # and push the entry
        writer.append(entry)


    def flush(self):

        # loop over writers
        for date, writer in self.writers.items():

            # and flush each one
            writer.flush()