#
#
#
from .reporter_top_sites_by_size   import *
from .reporter_top_sites_by_hits   import *
from .reporter_blocked_sites       import *
from .reporter_offensive_sites     import *
from .reporter_top_users_by_size   import *
from .reporter_top_users_by_hits   import *
from .reporter_blocked_users       import *
from .reporter_offensive_users     import *
from .reporter_search_queries      import *
from .reporter_youtube_videos      import *
from .reporter_detected_categories import *
from .reporter_triggered_policies  import *


#
#
#
class Factory:

    @staticmethod
    def create(stats_dir, reports_dir, report_type):

        if report_type == "top_sites_by_size":
            return TopSitesBySize(stats_dir, reports_dir)
        elif report_type == "top_sites_by_hits":
            return TopSitesByHits(stats_dir, reports_dir)
        elif report_type == "blocked_sites":
            return BlockedSites(stats_dir, reports_dir)
        elif report_type == "offensive_sites":
            return OffensiveSites(stats_dir, reports_dir)
        elif report_type == "top_users_by_size":
            return TopUsersBySize(stats_dir, reports_dir)
        elif report_type == "top_users_by_hits":
            return TopUsersByHits(stats_dir, reports_dir)
        elif report_type == "blocked_users":
            return BlockedUsers(stats_dir, reports_dir)
        elif report_type == "offensive_users":
            return OffensiveUsers(stats_dir, reports_dir)
        elif report_type == "search_queries":
            return SearchQueries(stats_dir, reports_dir)            
        elif report_type == "youtube_videos":
            return YouTubeVideos(stats_dir, reports_dir)
        elif report_type == "detected_categories":
            return DetectedCategories(stats_dir, reports_dir)
        elif report_type == "triggered_policies":
            return TriggeredPolicies(stats_dir, reports_dir)
        else:            
            raise Exception("cannot construct report of type '%s'" % report_type)
