import os

#
#
#
from jinja2 import Environment, FileSystemLoader, Template


#
# we use Jinja2 to render HTML templates
#
class Renderer:

    def __init__(self):

        self.base_dir      = os.path.dirname(os.path.abspath(__file__))
        self.templates_dir = os.path.join(self.base_dir, "templates")

    def render(self, template_name, context):

        assert(type(context) == dict)

        # create the loader
        loader = FileSystemLoader(self.templates_dir)
        env    = Environment(loader=loader)

        # load the report template
        template = env.get_template(template_name)

        # and render it
        return template.render(context)