import os
import numpy  as np

#
#
#
from django.template import loader, Context

#
#
#
from daemon.utils  import JsonWriter
from daemon.safety import categories_to_strings

# for now like this ugly
from daemon.stats.reporter.builders._impl.specific.generators import SearchesGenerator

#
#
#
from .reporter import Reporter
from .renderer import Renderer
from .loader   import Loader

#
#
#
class SearchQueries(Reporter):

    template_path = "search_queries.html"

    def report_impl(self, folder, config, df):

        # generate
        view = SearchesGenerator().generate(df)

        # save it
        view.to_csv(os.path.join(folder, "data.csv"), encoding='utf-8')

        # now render them as html
        text = Renderer().render(
            self.template_path, {
                "view"   : view,
                "config" : config,
                "meta"   : self.get_meta()
            }
        )

        # and save
        with open(os.path.join(folder, "index.html"), "w", encoding='utf-8') as fout:
            fout.write(text)

    def get_loader(self):

        parse_dates = []
        usecols     = [
            "ws_iid", 
            "timestamp", 
            "user_id", 
            "request_url", 
            "request_params",
            "fldomain", 
            "ws_policy"
        ]
        dtype       = {
            "ws_iid" : "uint64"
        }
        
        return Loader(parse_dates, usecols, dtype)


