import os
import json
import codecs
import pandas as pd

#
#
#
class SummaryAggregator:

    def aggregate(self, df):

        # and aggregate its info
        data = {
            "request_url_total"      : int( df['request_url_total'].sum() ),
            "request_size_total"     : int( df['request_size_total'].sum() ),
            "reply_size_total"       : int( df['reply_size_total'].sum() ),
            "ws_verdict_pass"        : int( df['ws_verdict_pass'].sum() ),
            "ws_verdict_adapt"       : int( df['ws_verdict_adapt'].sum() ),
            "ws_verdict_block"       : int( df['ws_verdict_block'].sum()),
            "ws_verdict_rescan"      : int( df['ws_verdict_rescan'].sum()),
            "ws_verdict_skip"        : int( df['ws_verdict_skip'].sum()),
            "ws_offensive"           : int( df['ws_offensive'].sum()),
            "users_count"            : int( df['users_count'].max() ),
            "domains_count"          : int( df['domains_count'].max() ),
            "policies_count"         : int( df['policies_count'].max() )
        }

        # calculate procent of blocked verdicts
        total   = data['ws_verdict_pass'] + data['ws_verdict_adapt'] + data['ws_verdict_block'] + data['ws_verdict_rescan'] + data['ws_verdict_skip']
        blocked = data['ws_verdict_block']

        data['block_percent'] = 0
        if total > 0:
            data['block_percent'] = int(round(100 * float(blocked) / float(total)))

        # return the json
        return data
