import os

#
#
#
from daemon.utils import JsonWriter

#
#
#
from .builder_item import ItemBuilder
from .generators   import DomainGenerator

#
# builder for individual domain
#
class DomainBuilder(ItemBuilder):

    def build_impl(self, df):

        # users
        self.build_requestors(
            df, 
            "user_id",
            os.path.join(self.folder, "users.csv"), 
            os.path.join(self.folder, "users.json")
        )

        # and finally time of day
        self.build_time_of_day(df)

    def build_requestors(self, df, group_by, name_csv, name_json):

        # generate
        (v, t) = DomainGenerator().generate(df, group_by)

        # save view
        v.to_csv(name_csv, encoding='utf-8')

        # save totals
        JsonWriter(name_json).write(t)

    def build_time_of_day(self, df):

        # create generateor
        g = DomainGenerator()

        # dump hits
        g.hourly_hits_per_user(df).to_csv(
            os.path.join(self.folder, "hourly_hits_per_user.csv"), encoding='utf-8'
        )
        
        # dump bandwidth
        g.hourly_bandwidth_per_user(df).to_csv(
            os.path.join(self.folder, "hourly_bandwidth_per_user.csv"), encoding='utf-8'
        )

        # dump uploads
        g.hourly_uploads_per_user(df).to_csv(
            os.path.join(self.folder, "hourly_uploads_per_user.csv"), encoding='utf-8'
        )
        