import numpy  as np
import pandas as pd

#
#
#
class FilesGenerator:

    def generate(self, dataframe):

        # get the array of columns to select from dataframe
        columns = self.get_columns()
        sort_by = self.sort_by()

        # create a new dataframe with needed columns
        df = dataframe[ 
            columns # ["timestamp", "user_id", "reply_size", "request_url"] 
        ].sort_values(sort_by, ascending=False)

        df.index.name = "ws_iid" 

        # and return first N of them
        return df.head(50)

#
#
#
class DownloadedFilesGenerator(FilesGenerator):

    def get_columns(self):
        return ["timestamp", "user_id", "reply_size", "request_url"]

    def sort_by(self):
        return "reply_size"


#
#
#
class UploadedFilesGenerator(FilesGenerator):

    def get_columns(self):
        return ["timestamp", "user_id", "request_size", "request_url"]

    def sort_by(self):
        return "request_size"
