import pandas as pd

#
#
#
class SummaryGenerator:

    def generate(self, df):

        # this is value to return
        data = {}

        # assign some general counts
        if True:

            # and assign it
            data ['request_url_total']  = int( df['request_url'].count() )
            data ['reply_size_total']   = int( df['reply_size'].sum() )
            data ['request_size_total'] = int(df['request_size'].sum())

        # see how many users we have
        if True:

            data['users_count']    = df['user_id'].nunique()            
            data['policies_count'] = df['ws_policy'].nunique()
            data['domains_count']  = df['fldomain'].nunique()

        # good now calculate how many entries where blocked
        if True:

            # verdict info
            data['ws_verdict_pass']   = int( df['ws_verdict_pass'].sum() )
            data['ws_verdict_adapt']  = int( df['ws_verdict_adapt'].sum() )
            data['ws_verdict_block']  = int( df['ws_verdict_block'].sum() )
            data['ws_verdict_rescan'] = int( df['ws_verdict_rescan'].sum() )
            data['ws_verdict_skip']   = int( df['ws_verdict_skip'].sum() )
            data['ws_offensive']      = int( df['ws_offensive'].sum() )

            # calculate procent of blocked verdicts   
            total   = data['ws_verdict_pass'] + data['ws_verdict_adapt'] + data['ws_verdict_block'] + data['ws_verdict_rescan'] + data['ws_verdict_skip'] 
            blocked = data['ws_verdict_block']

            data['block_percent'] = 0
            if total > 0:
                data['block_percent'] = int(round(100*float(blocked)/float(total)))
        
        return data
