import os
import re
import collections

#
# helper function to validate report dir
#
def is_valid_report_dir(folder):

    # if folder does not exist - not valid for sure
    if not os.path.isdir(folder):
        return False

    # check some files are indeed present (note files.csv is only present in day so not used here)
    names = ["summary.json", "hits.csv", "bytes.csv"]
    for name in names:
        if not os.path.isfile(os.path.join(folder, name)):
            return False

    # check some folders are indeed present
    names = ["domains", "users"]
    for name in names:
        if not os.path.isdir(os.path.join(folder, name)):
            return False

    # ok assume the folder is valid
    return True

