import os

#
#
#
from .builders.now import Builder

#
#
#
from daemon.stats.reporter.builders._impl.specific import DetailedInfoLimits

#
#
#
class NowReporter:

    def __init__(self, config):

        # debug check reports dir is fine
        assert(os.path.isdir(config.reports_dir))

        # save it
        self.reports_dir = config.reports_dir

    def report(self):

        # construct the folder name
        out_dir = os.path.join(self.reports_dir, "now")

        # construct the input data path
        data_csv = os.path.join(out_dir, "data.csv.gz")

        # create no limits for the builder (0 means show all)
        limits = DetailedInfoLimits()
        if True:
            limits.users_limit   = 0
            limits.domains_limit = 0

        # and run the generic reporter 
        r = Builder(out_dir)
        r.build(data_csv, limits)
