import os

#
#
#
from daemon.core  import System
from daemon.utils import Command

#
# a wrapper for the htpasswd command
#
class HtpasswdExe:

    def __init__(self):

        self.exe = "/usr/bin/htpasswd"

        if System.name() == System.WS_WINDOWS:
            self.exe = "m:\\websafety-ui\\tools\\htpasswd\\htpasswd.exe"

    def encode(self, pasw):

        # run the command to encode a password
        (exit_code, stdout, stderr) = Command.run( [self.exe, "-n", "-b", "default", pasw] )
        if exit_code != 0:
            raise Exception("Cannot encode the password, error %d, %s, %s." % (exit_code, stdout, stderr))

        # if we got here, everything is ok, so read the output as 
        lines = stdout.splitlines()
        if len(lines) < 1:
            raise Exception("Cannot encode the password, arrays of lines is too small %d, %s." % (len(lines), stdout))

        # get the first line and strip it
        line = lines[0].rstrip()

        if not line.startswith("default:"):
            raise Exception("Wring encode output, does not start with default: '%s'." % stdout)

        # cut off the default
        encoded = line[len("default:"):]

        # and return nicely
        return encoded
