import os
import subprocess

#
#
#
from daemon.core  import System

#
#
#
from .exe_sudo import ExeSudo

#
# accepts arguments as [] and returns (exit_code, stdout, stderr) or throws an exception
#
class Command:

    @staticmethod
    def run(args):

        # on windows prepend the path to python
        if System.name() == System.WS_WINDOWS:

            # see if the first argument is a python script thus ends with .py
            if args[0].endswith(".py"):
                args.insert(0, "c:\\Program Files (x86)\\Python36-32\\python.exe")
    
        # run this command
        process = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

        # wait until it is finished
        (stdout, stderr) = process.communicate()

        # in python3 the stdout is a byte line object now, so we convert them to strings
        stdout = stdout.decode("utf-8") 
        stderr = stderr.decode("utf-8") 

        # and return
        return (process.returncode, stdout, stderr)

#
#
#
class ElevatedCommand:

    @staticmethod
    def run(args):

        # prepend with path to sudo
        if System.name() != System.WS_WINDOWS:
            args.insert(0, ExeSudo.full_path())

        # and execute normally
        return Command.run(args)


