import os

#
#
#
from daemon.core import UiPath

#
#
#
from .command import ElevatedCommand

#
# publish means move into /opt/websafety/etc using elevation
#
class SudoPublisher:

    def publish_file(self, source_file, target_file):

        exe  = os.path.join(UiPath.bin_dir(), "fsmgr.py")
        arg1 = "--source-file=%s" % source_file
        arg2 = "--target-file=%s" % target_file
        args = [exe, arg1, arg2]

        (exit_code, stdout, stderr) = ElevatedCommand.run(args)

        # fail if failed
        if exit_code != 0:

            raise Exception(
                "Cannot copy file '%s' into '%s', exit code %d, stdout %s, stderr %s" % (
                    source_file, target_file, exit_code, stdout, stderr
                )
            )

    def remove_file(self, target_file):

        exe  = os.path.join(UiPath.bin_dir(), "fsmgr.py")
        arg1 = "--remove"
        arg2 = "--target-file=%s" % target_file
        args = [exe, arg1, arg2]

        (exit_code, stdout, stderr) = ElevatedCommand.run(args)

        # fail if failed
        if exit_code != 0:

            raise Exception(
                "Cannot remove file '%s', exit code %d, stdout %s, stderr %s" % (
                    target_file, exit_code, stdout, stderr
                )
            )

