import os

#
#
#
from daemon.core  import System

#
#
#
from .command import ElevatedCommand


#
#
#
class CommandTail:

    @staticmethod
    def run(log_file, line_count):

        try:

            # construct the path
            tail = "/usr/bin/tail"
            if System.name() == System.WS_WINDOWS:
                tail = "c:\\Program Files\\Git\\usr\\bin\\tail.exe"

            # construct the args
            args = [tail, "-n", str(line_count), log_file]
                
            # run this command
            (exit_code, stdout, stderr) = ElevatedCommand.run(args) 

            # and return
            return (exit_code, stdout, stderr)

        except Exception as e:
            return (-1, "", str(e))

#
# tailer reuses the system tail command to get the number of lines required
#
class Tailer:

    def __init__(self, filename):

        self.filename = filename

    def lines(self, line_count=256):

        # debug check just in case
        assert(isinstance(line_count, int))

        # 
        stdout = self.read_n(line_count)

        # split it
        return stdout.split("\n")

    def read_n(self, line_count):

        # debug check just in case
        assert(isinstance(line_count, int))

        # run the tail command
        (exit_code, stdout, stderr) = CommandTail.run(self.filename, line_count)

        # throw away if could not
        if 0 != exit_code:
            raise Exception("Cannot read the file %s, stderr: %s, stdout: %s" % (self.filename, stderr, stdout))

        # return normally
        return stdout