#!/usr/bin/env python3
import os
import sys
import argparse

#
#
#
from daemon.utils import FsMgr

#
# remove action
#
def perform_remove(args):

    fsmgr = FsMgr()
    fsmgr.remove_file("/etc/logrotate.d/squid")


#
# copy action
#
def perform_copy():

    # create actor, user and group names
    fsmgr = FsMgr()
    user  = "root"
    group = "root"

    # create names
    source_file = "/opt/websafety-ui/etc/squid/etc_logrotate_d_squid"
    target_file = "/etc/logrotate.d/squid"
    target_bak  = "/etc/logrotate.d/squid.bak"

    # copy, note the target file will be owned by root and it is ok
    fsmgr.copy_file(source_file, target_file)

    # remove the bak file if it was created
    if os.path.isfile(target_bak):
        os.unlink(target_bak)

#
# action dispatcher
#
def perform_action(args):

    # do what is needed
    if args.remove:
        perform_remove()
    else:
        perform_copy()

    # logrotate is run by the cron so it is not a daemon and we do NOT need to reload it
    # os.system("sudo systemctl restart logrotate")

#
# main
#
def main():

    # create parser
    parser = argparse.ArgumentParser(description='logrotatemgr.py entries publisher script.')

    # add args
    parser.add_argument("--remove", action='store_true', help="if set removes target folder or/and file")
    
    # parse actual arguments
    args = parser.parse_args()

    # ok let's go
    perform_action(args)

if __name__ == "__main__":

    # call the entry code
    main()

    # if we got here everything is fine
    sys.exit(0)
