import os
import yaml
import tempfile

#
#
#
from  daemon.core import UiPath, System, Distrib
from _domain.utils import CommandElevated

            
        

#
#
#
class NetPlanNetworkSettingsGenerator:

    def generate(self, contents):

        # debug check
        assert(type(contents) == dict)

        # first generate a temporary file in /opt/websafety-ui/etc/node folder (it will be removed after close automatically)
        prefix = "etc_netplan_yml."
        folder = os.path.join(UiPath.etc_dir(), "node")

        # write to temp file        
        with tempfile.NamedTemporaryFile(prefix=prefix, dir=folder, delete=True) as temp:

            yaml.dump(contents, temp, encoding=('utf-8'), default_flow_style=False)
            temp.flush()

            # call the sudoing binary
            exe  = os.path.join(UiPath.bin_dir(), "netmgr.py")
            arg1 = "--file=%s" % temp.name
            arg2 = "--system=%s" % System.name()
            arg3 = "--distrib=%s" % Distrib.name()
            args = [exe, arg1, arg2, arg3]

            # and run it
            (exit_code, stdout, stderr) = CommandElevated().run(args)
            if exit_code != 0:
                raise Exception("Cannot generate network settings. Error: %d, STDOUT: %s, STDERR: %s" % (exit_code, stdout, stderr))
