import os

#
#
#
from daemon.core import System, Distrib

#
#
#
class BinarySquid:

    @staticmethod
    def full_path():

        # get the name of the system
        system_name = System.name()

        # windows (for debug only)
        if system_name == System.WS_WINDOWS:
            return "c:\\Squid\\bin\\squid.exe"

        # it must be linux then
        assert(system_name == System.WS_LINUX)

        # see exactly what linux we have
        distrib_name = Distrib.name()

        # centos maybe
        if distrib_name in [Distrib.WS_REDHAT8]:
            return "/usr/sbin/squid"

        # then only debian or ubuntu
        assert(distrib_name in [Distrib.WS_DEBIAN11, Distrib.WS_UBUNTU20])

        # return nicely
        return "/usr/sbin/squid"

    @staticmethod
    def runas_user():  

        # get the name of the system
        system_name = System.name()

        if System.WS_WINDOWS == system_name:
            return "unknown"

        assert(System.WS_LINUX == system_name)

        if Distrib.name() in [Distrib.WS_REDHAT8]:
            return "squid"

        if Distrib.name() in [Distrib.WS_DEBIAN11, Distrib.WS_UBUNTU20]:
            return "proxy"

        raise Exception("Unknown distrib '%s' in BinarySquid.runas_user" % Distrib.name())

    @staticmethod
    def major_version():

    	# all of our distributions are now on Squid 4, so just return it always
    	return 4
