import traceback

#
#
#
from daemon.core import System, Distrib

#
#
#
from .conf_file import ConfReader
    
#
#
#
class SquidConf:

    def get_path(self):

        # windows (for debug only)
        if System.WS_WINDOWS == System.name():
            return "m:\\websafety_extra\\src.test\\res\\squid.conf"

        # debug check
        assert(System.WS_LINUX == System.name())

        # centos and redhat
        if Distrib.name() in [Distrib.WS_REDHAT8]:
            return "/etc/squid/squid.conf"

        # by default - debian and ubuntu
        return "/etc/squid/squid.conf"

    def get_str(self):

        result = ""

        try:
            
            path   = self.get_path()
            skip   = False
            lines  = ConfReader(path).read_lines(skip)
            result = '\n'.join(lines)

        except Exception as e:

            result  = str(e)
            result += "\n%s\n" % traceback.format_exc()

        return result
    