import os
import tempfile

#
#
#
from daemon.core import UiPath

#
#
#
class TempFolder:

    def __init__(self, prefix):

        # create a temp file and remove it after that - so we have a temp file name ready
        with tempfile.NamedTemporaryFile(prefix=prefix+"_", dir=os.path.join(UiPath.var_dir(), "temp"), delete=True) as temp:
            self.temp_dir = temp.name

        # make it on disk
        if not os.path.isdir(self.temp_dir):
            os.mkdir(self.temp_dir)

    def path(self):
        return self.temp_dir
