from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.views.generic import RedirectView
from django.urls import reverse_lazy, path
from django.conf.urls import url, include

from squid.views import AutoProxyDiscoverView
admin.autodiscover()

urlpatterns = [
    url(r'^accounts/login/$', auth_views.LoginView.as_view(template_name='login.html'), name="LoginView"),
    url(r'^accounts/logout/$',  auth_views.LogoutView.as_view(template_name='logged_out.html'), name="LogoutView"),
    url(r'^$', RedirectView.as_view(url=reverse_lazy('node:ViewDashboard'), permanent=False)),
    url(r'^frame/', include( ('frame.urls', 'frame'), namespace='frame')),    
    url(r'^node/', include( ('node.urls', 'node'), namespace='node')),
    url(r'^safety/', include( ('safety.urls', 'safety'), namespace='wf')),    
    path('squid/',     include(('squid.urls', 'squid'), namespace='squid')),
    path('antivirus/', include(('antivirus.urls', 'antivirus'), namespace='av')),
    path('traffic/',   include(('traffic.urls', 'traffic'), namespace='traffic')),
    url(r'^wpad.dat?$', AutoProxyDiscoverView.as_view(), name="AutoProxyDiscoverView"),
    url(r'^proxy.pac$', AutoProxyDiscoverView.as_view(), name="AutoProxyDiscoverView"),    
    path('admin/', admin.site.urls),
]