#
#
#
from daemon.core import System
from _domain.utils import Command

#
# a wrapper for the systemctl command
#
class CommandSystemCtl(Command):

    def __init__(self, daemon):

        self.daemon = daemon

    def run(self):

        # check we are running linux
        if System.WS_LINUX != System.name():
            raise Exception("systemctl is only supported on Linux")

        if System.in_docker():
            args = ["/usr/bin/sv", "status", self.daemon]
        else:
            args = ["/bin/systemctl", "status", self.daemon, "--no-pager"]

        # run this command
        (exit_code, stdout, stderr) = Command.run(self, args)

        # and convert
        if exit_code == 0:
            return stdout

        # raise in case of any failure
        raise Exception("Cannot run the command [%s], exit code %d, output: %s" % (' '.join(args), exit_code, stdout+stderr))
