#!/usr/bin/env python3
#
# (c) Diladele B.V. 2018, Web Safety for Squid Proxy
#  
# Reset root password automation script for Amazon AWS
#
import os
import django 
import logging
import argparse

#
# tell Django where to read settings from
#
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'console.settings'); 

#
# setup django
#
django.setup(); 

#
# we wil be using the User model
#
from django.contrib.auth.models import User

#
#
#
def set_root_password(new_pass):

    u = User.objects.get(username='root')
    u.set_password(new_pass)
    u.save()


#
# main
#
def main():
    
    # define arguments
    parser = argparse.ArgumentParser(description='Reset root password automation script for Amazon AWS')
    parser.add_argument("--password", help="new root password", required=True)

    # parse them
    args = parser.parse_args()    

    logging.basicConfig(format='%(asctime)s %(message)s', level=logging.INFO)   
        
    # set the password
    set_root_password(args.password)

    # and tell it
    logging.info("Password reset %s successfully. Please login into Web UI and check if everything is ok!" % args.password)

#
#
#

if __name__ == '__main__':

    main()