#
#
#
from safety.models import MemberHeader
from utility.validator import AddressIP, AddressSubnet, AddressRange, AsciiOnly, NoWildcards, NotUrl, Strip, NoWhiteSpaces


#
#
#
from .member_base import *

#
#
#
class ViewMemberHeaderList(ViewMemberList):

    model         = MemberHeader
    template_name = "safety/members/header_list.html"

#
#
#
class MemberHeaderForm(MemberForm):

    class Meta:
        model = MemberHeader    
        fields = '__all__'

    def clean_value(self):

        value = Strip.clean(self.cleaned_data['value'])
        if len(value) < 3:
            raise forms.ValidationError("Header '%s' cannot be added, becase it is too short." % (value) )

        value = AsciiOnly.clean(value)
        value = NoWildcards.clean(value)
        value = NotUrl.clean(value)
        value = NoWhiteSpaces.clean(value)
        
        return value

#
#
#
class ViewMemberHeaderCreate(ViewMemberCreate):

    model           = MemberHeader
    form_class      = MemberHeaderForm
    template_name   = "safety/members/header_form.html"

#
#
#
class ViewMemberHeaderUpdate(ViewMemberUpdate):

    model           = MemberHeader
    form_class      = MemberHeaderForm
    template_name   = "safety/members/header_form.html"
