import re
#
#
#
from django import forms
from django.views import generic
from django.http  import HttpResponseRedirect
from django.urls import reverse
from django.contrib import messages
from django.contrib.messages.views import SuccessMessageMixin
from django.shortcuts import get_object_or_404

#
#
#
#from _domain.antivirus import WsGsbLog, WsGsbStatus

#
#
#
from safety.models import *
from django import forms

from .policy_items import PolicyMixin, ListViewEx

#from .items import ViewItemList, ViewItemCreate, ViewItemUpdate
#
#
#

class RuleYouTubeForm(forms.ModelForm):

    class Meta:

        model  = RuleYouTube
        fields = ['enable', 'action', 'restrictions', 'hide_comments', 'hide_suggestions', 'hide_other']

    '''
    def clean_deny_url(self):

        value = self.cleaned_data['deny_url']
        value = value.strip().lower()

        if not (value.startswith("http://") or value.startswith("https://")):
            raise forms.ValidationError("Deny URL must start with http:// or https:// instead of %s." % value)

        return value
    '''


class ViewRuleYouTubeEdit(SuccessMessageMixin, PolicyMixin, generic.edit.UpdateView):

    model           = RuleYouTube
    form_class      = RuleYouTubeForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutube_form.html"

    def get_object(self):
        return RuleYouTube.objects.filter(policy_id=self.kwargs["pid"]).first()

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeEdit", kwargs={'pid':self.kwargs['pid']})


#
#
#
class ViewRuleYouTubeCategoryEdit(SuccessMessageMixin, PolicyMixin, generic.edit.UpdateView):

    model           = RuleYouTubeCategory
    success_message = "need_squid_reload"
    fields          = [
        'block_film_and_animation', 
        'block_autos_and_vehicles', 
        'block_music', 
        'block_pets_and_animals', 
        'block_sports', 
        'block_short_movies',
        'block_travel_and_events',
        'block_gaming',
        'block_videoblogging',
        'block_people_and_blogs',
        'block_comedy',
        'block_entertainment',
        'block_news_and_politics',
        'block_howto_and_style',
        'block_education',
        'block_science_and_technology',
        'block_nonprofits_and_activism',
        'block_movies',
        'block_anime_animation',
        'block_action_adventure',
        'block_classics',
        'block_documentary',
        'block_drama',
        'block_family',
        'block_foreign',
        'block_horror',
        'block_sci_fi_fantasy',
        'block_thriller',
        'block_shorts',
        'block_shows',
        'block_trailers'
    ]
    template_name   = "safety/rules/ruleyoutubecategory_list.html"

    def get_object(self):
        return RuleYouTubeCategory.objects.filter(policy_id=self.kwargs["pid"]).first()

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeCategoryEdit", kwargs={'pid':self.kwargs['pid']})


#
# allowed channels
#
class ViewRuleYouTubeAllowChannelList(PolicyMixin, ListViewEx):

    model           = RuleYouTubeAllowChannel
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowchannel_list.html"

    def get_queryset(self):
        return RuleYouTubeAllowChannel.objects.filter(policy_id=self.kwargs["pid"])
    
    def get_success_url(self): 
        return reverse("wf:ViewRuleYouTubeAllowChannelList", kwargs={'pid':self.kwargs['pid']})

class RuleYouTubeAllowChannelForm(forms.ModelForm):

    class Meta:
        model  = RuleYouTubeAllowChannel
        fields = ['policy', 'channel_id', 'title', 'description']

class ViewRuleYouTubeAllowChannelCreate(PolicyMixin, SuccessMessageMixin, generic.edit.CreateView):

    model           = RuleYouTubeAllowChannel
    form_class      = RuleYouTubeAllowChannelForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowchannel_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeAllowChannelList", kwargs={'pid':self.kwargs['pid']})


    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeAllowChannelCreate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


class ViewRuleYouTubeAllowChannelUpdate(PolicyMixin, SuccessMessageMixin, generic.edit.UpdateView):

    model           = RuleYouTubeAllowChannel
    form_class      = RuleYouTubeAllowChannelForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowchannel_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeAllowChannelList", kwargs={'pid':self.kwargs['pid']})

    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeAllowChannelUpdate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context

#
# blocked channels
#
class ViewRuleYouTubeBlockChannelList(PolicyMixin, ListViewEx):

    model           = RuleYouTubeBlockChannel
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockchannel_list.html"

    def get_queryset(self):
        return RuleYouTubeBlockChannel.objects.filter(policy_id=self.kwargs["pid"])
    
    def get_success_url(self): 
        return reverse("wf:ViewRuleYouTubeBlockChannelList", kwargs={'pid':self.kwargs['pid']})

class RuleYouTubeBlockChannelForm(forms.ModelForm):

    class Meta:
        model  = RuleYouTubeBlockChannel
        fields = ['policy', 'channel_id', 'title', 'description']

class ViewRuleYouTubeBlockChannelCreate(PolicyMixin, SuccessMessageMixin, generic.edit.CreateView):

    model           = RuleYouTubeBlockChannel
    form_class      = RuleYouTubeBlockChannelForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockchannel_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeBlockChannelList", kwargs={'pid':self.kwargs['pid']})


    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeBlockChannelCreate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


class ViewRuleYouTubeBlockChannelUpdate(PolicyMixin, SuccessMessageMixin, generic.edit.UpdateView):

    model           = RuleYouTubeBlockChannel
    form_class      = RuleYouTubeBlockChannelForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockchannel_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeBlockChannelList", kwargs={'pid':self.kwargs['pid']})

    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeBlockChannelUpdate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context

#
# allowed videos
#
class ViewRuleYouTubeAllowVideoList(PolicyMixin, ListViewEx):

    model           = RuleYouTubeAllowVideo
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowvideo_list.html"

    def get_queryset(self):
        return RuleYouTubeAllowVideo.objects.filter(policy_id=self.kwargs["pid"])
    
    def get_success_url(self): 
        return reverse("wf:ViewRuleYouTubeAllowVideoList", kwargs={'pid':self.kwargs['pid']})

class RuleYouTubeAllowVideoForm(forms.ModelForm):

    class Meta:
        model  = RuleYouTubeAllowVideo
        fields = ['policy', 'video_id', 'channel_id', 'category_id', 'title', 'description']

class ViewRuleYouTubeAllowVideoCreate(PolicyMixin, SuccessMessageMixin, generic.edit.CreateView):

    model           = RuleYouTubeAllowVideo
    form_class      = RuleYouTubeAllowVideoForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowvideo_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeAllowVideoList", kwargs={'pid':self.kwargs['pid']})


    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeAllowVideoCreate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


class ViewRuleYouTubeAllowVideoUpdate(PolicyMixin, SuccessMessageMixin, generic.edit.UpdateView):

    model           = RuleYouTubeAllowVideo
    form_class      = RuleYouTubeAllowVideoForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeallowvideo_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeAllowVideoList", kwargs={'pid':self.kwargs['pid']})

    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeAllowVideoUpdate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


#
# blocked videos
#
class ViewRuleYouTubeBlockVideoList(PolicyMixin, ListViewEx):

    model           = RuleYouTubeBlockVideo
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockvideo_list.html"

    def get_queryset(self):
        return RuleYouTubeBlockVideo.objects.filter(policy_id=self.kwargs["pid"])
    
    def get_success_url(self): 
        return reverse("wf:ViewRuleYouTubeBlockVideoList", kwargs={'pid':self.kwargs['pid']})

class RuleYouTubeBlockVideoForm(forms.ModelForm):

    class Meta:
        model  = RuleYouTubeBlockVideo
        fields = ['policy', 'video_id', 'channel_id', 'category_id', 'title', 'description']

class ViewRuleYouTubeBlockVideoCreate(PolicyMixin, SuccessMessageMixin, generic.edit.CreateView):

    model           = RuleYouTubeBlockVideo
    form_class      = RuleYouTubeBlockVideoForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockvideo_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeBlockVideoList", kwargs={'pid':self.kwargs['pid']})


    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeBlockVideoCreate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


class ViewRuleYouTubeBlockVideoUpdate(PolicyMixin, SuccessMessageMixin, generic.edit.UpdateView):

    model           = RuleYouTubeBlockVideo
    form_class      = RuleYouTubeBlockVideoForm
    success_message = "need_squid_reload"
    template_name   = "safety/rules/ruleyoutubeblockvideo_form.html"

    def get_success_url(self):
        return reverse("wf:ViewRuleYouTubeBlockVideoList", kwargs={'pid':self.kwargs['pid']})

    def get_context_data(self, **kwargs):

        context  = super(ViewRuleYouTubeBlockVideoUpdate, self).get_context_data(**kwargs)
        context['youtube'] = YouTube.objects.first()
        return context


'''
#
#
#
class ViewYouTubeHelpers(SuccessMessageMixin, generic.edit.UpdateView):

    model           = YouTubeGuard
    fields          = ['helper_verbose', 'helper_total', 'helper_idle', 'helper_startup']
    
    success_message = "need_squid_restart"
    template_name   = "antivirus/youtube/helpers_form.html"

    def get_object(self):
        return YouTubeGuard.objects.first()

    def get_success_url(self):
        return reverse("wf:ViewYouTubeHelpers")






#
# blocked channels
#
class ViewYouTubeBlockedChannelList(ViewItemList):

    model         = YouTubeBlockChannel
    template_name = "antivirus/youtube/blocked_channel_list.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedChannelList")

class YouTubeBlockChannelForm(forms.ModelForm):

    class Meta:
        model  = YouTubeBlockChannel
        fields = ['channel_id', 'title', 'description']

class ViewYouTubeBlockedChannelCreate(ViewItemCreate):

    model         = YouTubeBlockChannel
    form_class    = YouTubeBlockChannelForm
    template_name = "antivirus/youtube/blocked_channel_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedChannelList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeBlockedChannelCreate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context

class ViewYouTubeBlockedChannelUpdate(ViewItemUpdate):

    model         = YouTubeBlockChannel
    form_class    = YouTubeBlockChannelForm
    template_name = "antivirus/youtube/blocked_channel_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedChannelList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeBlockedChannelUpdate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context

#
# allowed videos
#
class ViewYouTubeAllowedVideoList(ViewItemList):

    model         = YouTubeAllowVideo
    template_name = "antivirus/youtube/allowed_video_list.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeAllowedVideoList")

class YouTubeAllowVideoForm(forms.ModelForm):

    class Meta:
        model  = YouTubeAllowVideo
        fields = ['video_id', 'channel_id', 'category_id', 'title', 'description' ]

class ViewYouTubeAllowedVideoCreate(ViewItemCreate):

    model         = YouTubeAllowVideo
    form_class    = YouTubeAllowVideoForm
    template_name = "antivirus/youtube/allowed_video_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeAllowedVideoList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeAllowedVideoCreate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context

class ViewYouTubeAllowedVideoUpdate(ViewItemUpdate):

    model         = YouTubeAllowVideo
    form_class    = YouTubeAllowVideoForm
    template_name = "antivirus/youtube/allowed_video_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeAllowedVideoList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeAllowedVideoUpdate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context

#
# blocked videos
#
class ViewYouTubeBlockedVideoList(ViewItemList):

    model         = YouTubeBlockVideo
    template_name = "antivirus/youtube/blocked_video_list.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedVideoList")

class YouTubeBlockVideoForm(forms.ModelForm):

    class Meta:
        model  = YouTubeBlockVideo
        fields = ['video_id', 'channel_id', 'category_id', 'title', 'description' ]

class ViewYouTubeBlockedVideoCreate(ViewItemCreate):

    model         = YouTubeBlockVideo
    form_class    = YouTubeBlockVideoForm
    template_name = "antivirus/youtube/blocked_video_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedVideoList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeBlockedVideoCreate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context

class ViewYouTubeBlockedVideoUpdate(ViewItemUpdate):

    model         = YouTubeBlockVideo
    form_class    = YouTubeBlockVideoForm
    template_name = "antivirus/youtube/blocked_video_form.html"
    
    def get_success_url(self): 
        return reverse("wf:ViewYouTubeBlockedVideoList")

    def get_context_data(self, **kwargs):

        context  = super(ViewYouTubeBlockedVideoUpdate, self).get_context_data(**kwargs)
        context['guard'] = YouTubeGuard.objects.first()
        return context







#
# 
#
class ViewSafeBrowsingLog(generic.base.TemplateView):

    template_name = "antivirus/safe_browsing/log.html"
    
    def get_context_data(self, **kwargs):

        context = super(ViewSafeBrowsingLog, self).get_context_data(**kwargs)        

        # get size, include and exclude strings from request
        include = self.request.GET.get('include', '')
        exclude = self.request.GET.get('exclude', '')
        size    = 256
        try:
            size = int(self.request.GET.get('size', '256'))
            if size > 1024:
                size = 1024
        except Exception, e:
            pass

        # save into context
        context['size']         = size
        context['include']      = include
        context['exclude']      = exclude
        context['log_contents'] = self.get_contents(size, include, exclude)
        context['log_size']     = self.get_size()
        context['log_path']     = WsGsbLog().get_path()

        return context

    def get_size(self):

        log  = WsGsbLog()
        size = log.get_size()
       
        return size

    def get_contents(self, line_count, include, exclude):

        log      = WsGsbLog()
        contents = log.get_contents(line_count, include, exclude)
        if not contents:
            contents = "Requested log file is empty."
        
        return contents


#
# 
#
class ViewSafeBrowsingStatus(generic.base.TemplateView):

    template_name = "antivirus/safe_browsing/status.html"
    
    def get_context_data(self, **kwargs):

        context = super(ViewSafeBrowsingStatus, self).get_context_data(**kwargs)

        # allocate default info
        data = {
            "Stats" : {
                "QueriesByDatabase": 0,
                "QueriesByCache":    0,
                "QueriesByAPI":      0,
                "QueriesFail":       0,
                "DatabaseUpdateLag": 0
            },
            "Error":""
        }
        
        try:
            # get the wsgsbd port for the REST service
            port = 18890

            #name = os.path.join(Paths.etc_dir(), "node", "wssyncd.json")
            #with open(name) as fin:    
            #    wssyncd = json.load(fin)
            #    wsport  = wssyncd['rest_service']['port']
            #

            data = WsGsbStatus().run(port)
            
        except Exception as e:
            data['Error'] = str(e)
        
        context['info'] = data

        return context

    def get_size(self):

        log  = self.log_class()
        size = log.get_size()
       
        return size

    def get_contents(self, line_count, include, exclude):

        log      = self.log_class()
        contents = log.get_contents(line_count, include, exclude)
        if not contents:
            contents = "Requested log file is empty."
        
        return contents
'''