#
# django
#
from django.conf.urls import url
from django.urls import path

#
# our
#
from . import views

#
#
#
urlpatterns = [

    # general
    path('general/config',  views.ViewGeneralConfig.as_view(),  name='ViewGeneralConfig'),
    path('general/parse',   views.ViewGeneralParse.as_view(),   name='ViewGeneralParse'),
    path('general/version', views.ViewGeneralVersion.as_view(), name='ViewGeneralVersion'),

    # runtime
    path('runtime/mgrinfo', views.ViewRuntime.as_view(template_name="squid/general/mgrinfo.html"), name='ViewRuntimeMgrInfo'),
    path('runtime/counters', views.ViewRuntime.as_view(template_name="squid/general/counters.html"), name='ViewRuntimeCounters'),
    path('runtime/counters/min5', views.ViewRuntime.as_view(template_name="squid/general/5min.html"), name='ViewRuntimeCountersMin5'),
    path('runtime/counters/min60', views.ViewRuntime.as_view(template_name="squid/general/60min.html"), name='ViewRuntimeCountersMin60'),
    path('runtime/utilization', views.ViewRuntime.as_view(template_name="squid/general/utilization.html"), name='ViewRuntimeUtilization'),
    path('runtime/dnsinfo', views.ViewRuntime.as_view(template_name="squid/general/dnsinfo.html"), name='ViewRuntimeDnsInfo'),
    path('runtime/delay', views.ViewRuntime.as_view(template_name="squid/general/delay.html"), name='ViewRuntimeDelay'),
    path('runtime/auth/negotiate', views.ViewRuntime.as_view(template_name="squid/general/auth_negotiate.html"), name='ViewRuntimeAuthNegotiate'),
    path('runtime/auth/ntlm', views.ViewRuntime.as_view(template_name="squid/general/auth_ntlm.html"), name='ViewRuntimeAuthNtlm'),
    path('runtime/auth/basic', views.ViewRuntime.as_view(template_name="squid/general/auth_basic.html"), name='ViewRuntimeAuthBasic'),
    path('runtime/client/list', views.ViewRuntime.as_view(template_name="squid/general/client_list.html"), name='ViewRuntimeClientList'),
    path('runtime/active/requests', views.ViewRuntime.as_view(template_name="squid/general/active_requests.html"), name='ViewRuntimeActiveRequests'),

    # settings
    path('network/info', views.ViewNetworkInfo.as_view(), name='ViewNetworkInfo'),
    path('acls', views.ViewAcls.as_view(), name='ViewAcls'),
    path('administrative', views.ViewAdministrative.as_view(), name='ViewAdministrative'),
    path('dns', views.ViewDns.as_view(), name='ViewDns'),
    path('miscellaneous', views.ViewMiscellaneous.as_view(), name='ViewMiscellaneous'),
    
    # ssl
    path('ssl/info', views.ViewSslInfo.as_view(), name='ViewSslInfo'),
    path('ssl/cert', views.ViewSslRootCa.as_view(), name='ViewSslRootCa'),    

    url(r'^ssl/der$', views.ViewSslDer.as_view(), name='ViewSslDer'),
    url(r'^ssl/pem/backup$', views.ViewSslPemBackUp.as_view(), name='ViewSslPemBackUp'),
    url(r'^ssl/pem/upload$', views.ViewSslPemUpload.as_view(), name='ViewSslPemUpload'),
    url(r'^ssl/pem/generate$', views.ViewSslPemGenerate.as_view(), name='ViewSslPemGenerate'),
    url(r'^ssl/target/domain/list$', views.ViewSslTargetDomainList.as_view(), name='ViewSslTargetDomainList'),
    url(r'^ssl/target/domain/create$', views.ViewSslTargetDomainCreate.as_view(), name='ViewSslTargetDomainCreate'),
    url(r'^ssl/target/domain/(?P<pk>\d+)/update$', views.ViewSslTargetDomainUpdate.as_view(), name='ViewSslTargetDomainUpdate'),
    url(r'^ssl/target/ip/list$', views.ViewSslTargetIpList.as_view(), name='ViewSslTargetIpList'),
    url(r'^ssl/target/ip/create$', views.ViewSslTargetIpCreate.as_view(), name='ViewSslTargetIpCreate'),
    url(r'^ssl/target/ip/(?P<pk>\d+)/update$', views.ViewSslTargetIpUpdate.as_view(), name='ViewSslTargetIpUpdate'),
    url(r'^ssl/target/subnet/list$', views.ViewSslTargetSubnetList.as_view(), name='ViewSslTargetSubnetList'),
    url(r'^ssl/target/subnet/create$', views.ViewSslTargetSubnetCreate.as_view(), name='ViewSslTargetSubnetCreate'),
    url(r'^ssl/target/subnet/(?P<pk>\d+)/update$', views.ViewSslTargetSubnetUpdate.as_view(), name='ViewSslTargetSubnetUpdate'),
    url(r'^ssl/error/domain/list$', views.ViewSslErrorDomainList.as_view(), name='ViewSslErrorDomainList'),
    url(r'^ssl/error/domain/create$', views.ViewSslErrorDomainCreate.as_view(), name='ViewSslErrorDomainCreate'),
    url(r'^ssl/error/domain/(?P<pk>\d+)/update$', views.ViewSslErrorDomainUpdate.as_view(), name='ViewSslErrorDomainUpdate'),
    url(r'^ssl/error/ip/list$', views.ViewSslErrorIpList.as_view(), name='ViewSslErrorIpList'),
    url(r'^ssl/error/ip/create$', views.ViewSslErrorIpCreate.as_view(), name='ViewSslErrorIpCreate'),
    url(r'^ssl/error/ip/(?P<pk>\d+)/update$', views.ViewSslErrorIpUpdate.as_view(), name='ViewSslErrorIpUpdate'),
    url(r'^ssl/error/subnet/list$', views.ViewSslErrorSubnetList.as_view(), name='ViewSslErrorSubnetList'),
    url(r'^ssl/error/subnet/create$', views.ViewSslErrorSubnetCreate.as_view(), name='ViewSslErrorSubnetCreate'),
    url(r'^ssl/error/subnet/(?P<pk>\d+)/update$', views.ViewSslErrorSubnetUpdate.as_view(), name='ViewSslErrorSubnetUpdate'),
    url(r'^ssl/missing/certs/list$', views.ViewSslIntermediateCertList.as_view(), name='ViewSslIntermediateCertList'),
    url(r'^ssl/missing/certs/create$', views.ViewSslIntermediateCertCreate.as_view(), name='ViewSslIntermediateCertCreate'),
    url(r'^ssl/missing/certs/backup$', views.ViewSslIntermediateCertBackUp.as_view(), name='ViewSslIntermediateCertBackUp'),

    # exclusions    
    url(r'^exclude/domain/name/list$',                 views.ViewExcludeDomainNameList.as_view(),     name='ViewExcludeDomainNameList'),
    url(r'^exclude/domain/name/create$',               views.ViewExcludeDomainNameCreate.as_view(),   name='ViewExcludeDomainNameCreate'),
    url(r'^exclude/domain/name/(?P<pk>\d+)/update$',   views.ViewExcludeDomainNameUpdate.as_view(),   name='ViewExcludeDomainNameUpdate'),
    url(r'^exclude/domain/ip/list$',                   views.ViewExcludeDomainIpList.as_view(),       name='ViewExcludeDomainIpList'),
    url(r'^exclude/domain/ip/create$',                 views.ViewExcludeDomainIpCreate.as_view(),     name='ViewExcludeDomainIpCreate'),
    url(r'^exclude/domain/ip/(?P<pk>\d+)/update$',     views.ViewExcludeDomainIpUpdate.as_view(),     name='ViewExcludeDomainIpUpdate'),
    url(r'^exclude/domain/range/list$',                views.ViewExcludeDomainRangeList.as_view(),    name='ViewExcludeDomainRangeList'),
    url(r'^exclude/domain/range/create$',              views.ViewExcludeDomainRangeCreate.as_view(),  name='ViewExcludeDomainRangeCreate'),
    url(r'^exclude/domain/range/(?P<pk>\d+)/update$',  views.ViewExcludeDomainRangeUpdate.as_view(),  name='ViewExcludeDomainRangeUpdate'),
    url(r'^exclude/domain/subnet/list$',               views.ViewExcludeDomainSubnetList.as_view(),   name='ViewExcludeDomainSubnetList'),
    url(r'^exclude/domain/subnet/create$',             views.ViewExcludeDomainSubnetCreate.as_view(), name='ViewExcludeDomainSubnetCreate'),
    url(r'^exclude/domain/subnet/(?P<pk>\d+)/update$', views.ViewExcludeDomainSubnetUpdate.as_view(), name='ViewExcludeDomainSubnetUpdate'),
    url(r'^exclude/user/ip/list$',                     views.ViewExcludeUserIpList.as_view(),         name='ViewExcludeUserIpList'),
    url(r'^exclude/user/ip/create$',                   views.ViewExcludeUserIpCreate.as_view(),       name='ViewExcludeUserIpCreate'),
    url(r'^exclude/user/ip/(?P<pk>\d+)/update$',       views.ViewExcludeUserIpUpdate.as_view(),       name='ViewExcludeUserIpUpdate'),
    url(r'^exclude/user/range/list$',                  views.ViewExcludeUserRangeList.as_view(),      name='ViewExcludeUserRangeList'),
    url(r'^exclude/user/range/create$',                views.ViewExcludeUserRangeCreate.as_view(),    name='ViewExcludeUserRangeCreate'),
    url(r'^exclude/user/range/(?P<pk>\d+)/update$',    views.ViewExcludeUserRangeUpdate.as_view(),    name='ViewExcludeUserRangeUpdate'),
    url(r'^exclude/user/subnet/list$',                 views.ViewExcludeUserSubnetList.as_view(),     name='ViewExcludeUserSubnetList'),
    url(r'^exclude/user/subnet/create$',               views.ViewExcludeUserSubnetCreate.as_view(),   name='ViewExcludeUserSubnetCreate'),
    url(r'^exclude/user/subnet/(?P<pk>\d+)/update$',   views.ViewExcludeUserSubnetUpdate.as_view(),   name='ViewExcludeUserSubnetUpdate'),    
    url(r'^exclude/user/agent/list$',                  views.ViewExcludeUserAgentList.as_view(),      name='ViewExcludeUserAgentList'),
    url(r'^exclude/user/agent/create$',                views.ViewExcludeUserAgentCreate.as_view(),    name='ViewExcludeUserAgentCreate'),
    url(r'^exclude/user/agent/(?P<pk>\d+)/update$',    views.ViewExcludeUserAgentUpdate.as_view(),    name='ViewExcludeUserAgentUpdate'),
    url(r'^exclude/content/type/list$',                views.ViewExcludeContentTypeList.as_view(),    name='ViewExcludeContentTypeList'),
    url(r'^exclude/content/type/create$',              views.ViewExcludeContentTypeCreate.as_view(),  name='ViewExcludeContentTypeCreate'),
    url(r'^exclude/content/type/(?P<pk>\d+)/update$',  views.ViewExcludeContentTypeUpdate.as_view(),  name='ViewExcludeContentTypeUpdate'),
    url(r'^exclude/schedule/list$',                    views.ViewExcludeScheduleList.as_view(),       name='ViewExcludeScheduleList'),
    url(r'^exclude/schedule/create$',                  views.ViewExcludeScheduleCreate.as_view(),     name='ViewExcludeScheduleCreate'),
    url(r'^exclude/schedule/(?P<pk>\d+)/update$',      views.ViewExcludeScheduleUpdate.as_view(),     name='ViewExcludeScheduleUpdate'),
    url(r'^exclude/advanced/ssl$',                     views.ViewExcludeAdvancedSsl.as_view(),        name='ViewExcludeAdvancedSsl'),    
    url(r'^exclude/advanced/adaptation$',              views.ViewExcludeAdvancedAdaptation.as_view(), name='ViewExcludeAdvancedAdaptation'),
    url(r'^exclude/advanced/auth$',                    views.ViewExcludeAdvancedAuth.as_view(),       name='ViewExcludeAdvancedAuth'),
    url(r'^exclude/advanced/cache$',                   views.ViewExcludeAdvancedCache.as_view(),      name='ViewExcludeAdvancedCache'),
    url(r'^exclude/advanced/urlrewriter$',             views.ViewExcludeAdvancedUrlRewriter.as_view(),name='ViewExcludeAdvancedUrlRewriter'),
    url(r'^exclude/category/update$',                  views.ViewExcludeCategoryUpdate.as_view(),     name='ViewExcludeCategoryUpdate'),

    # auth
    path('auth/mode/explicit', views.ViewAuthExplicit.as_view(), name='ViewAuthExplicit'),
    path('auth/mode/pseudo', views.ViewAuthPseudo.as_view(), name='ViewAuthPseudo'),
    path('auth/domain/edit', views.ViewAuthDomainEdit.as_view(), name='ViewAuthDomainEdit'),
    path('auth/domain/test', views.ViewAuthDomainTest.as_view(), name='ViewAuthDomainTest'),    
    path('auth/domain/ldaps', views.ViewAuthDomainLdaps.as_view(), name='ViewAuthDomainLdaps'),
    path('auth/domain/ldaps/export', views.ViewAuthDomainLdapsExport.as_view(), name='ViewAuthDomainLdapsExport'),
    path('auth/domain/ldaps/remove', views.ViewAuthDomainLdapsRemove.as_view(), name='ViewAuthDomainLdapsRemove'),
    path('auth/domain/ldaps/detect', views.ViewLdapsDetect.as_view(), name='ViewLdapsDetect'),
    path('auth/detect', views.ViewAuthDetect.as_view(), name='ViewAuthDetect'),
    path('auth/group/edit', views.ViewAuthGroupMembershipEdit.as_view(), name='ViewAuthGroupMembershipEdit'),
    path('auth/negotiate/scheme/edit', views.ViewAuthNegotiateSchemeEdit.as_view(), name='ViewAuthNegotiateSchemeEdit'),
    path('auth/negotiate/scheme/download/keytab', views.ViewAuthNegotiateSchemeGetKeyTab.as_view(), name='ViewAuthNegotiateSchemeGetKeyTab'),
    path('auth/ntlm/scheme/edit', views.ViewAuthNtlmSchemeEdit.as_view(), name='ViewAuthNtlmSchemeEdit'),
    path('auth/ldap/scheme/edit', views.ViewAuthLdapSchemeEdit.as_view(), name='ViewAuthLdapSchemeEdit'),
    
    path('auth/localdb/edit', views.ViewAuthLocalDbEdit.as_view(), name='ViewAuthLocalDbEdit'),
    path('auth/localdb/user/list', views.ViewAuthLocalDbUsersList.as_view(), name='ViewAuthLocalDbUsersList'),
    path('auth/localdb/user/create', views.ViewAuthLocalDbUsersCreate.as_view(), name='ViewAuthLocalDbUsersCreate'),
    path('auth/localdb/user/<slug:pk>/edit', views.ViewAuthLocalDbUsersUpdate.as_view(), name='ViewAuthLocalDbUsersUpdate'),
    path('auth/localdb/export', views.ViewAuthLocalDbExport.as_view(), name='ViewAuthLocalDbExport'),
    path('auth/localdb/import', views.ViewAuthLocalDbImport.as_view(), name='ViewAuthLocalDbImport'),
    
    path('auth/radius/edit', views.ViewAuthRadiusEdit.as_view(), name='ViewAuthRadiusEdit'),
    
    url(r'^auth/label/edit$', views.ViewAuthLabelEdit.as_view(), name='ViewAuthLabelEdit'),
    url(r'^auth/label/user/list/$', views.ViewAuthLabelList.as_view(), name='ViewAuthLabelList'),
    url(r'^auth/label/user/(?P<pk>[\w\.]+)/edit/$', views.ViewAuthLabelUpdate.as_view(), name='ViewAuthLabelUpdate'),
    url(r'^auth/label/user/create/$', views.ViewAuthLabelCreate.as_view(), name='ViewAuthLabelCreate'),

    url(r'^auth/pseudo/edit$', views.ViewAuthPseudoEdit.as_view(), name='ViewAuthPseudoEdit'),
    url(r'^auth/pseudo/user/list/$', views.ViewAuthPseudoList.as_view(), name='ViewAuthPseudoList'),
    
    # tools
    url(r'^tools/upload$', views.ToolsUploadSquidFile.as_view(), name='ToolsUploadSquidFile'),
    url(r'^tools/wpad/upload$', views.ToolsUploadWpad.as_view(), name='ToolsUploadWpad'),
    url(r'^tools/wpad/remove$', views.ToolsRemoveWpad.as_view(), name='ToolsRemoveWpad'),
    
    # logs
    path('logs/access/log', views.ViewAccessLog.as_view(), name='ViewAccessLog'),
    path('logs/cache/log', views.ViewCacheLog.as_view(), name='ViewCacheLog'),
    path('logs/levels', views.ViewLogLevels.as_view(), name='ViewLogLevels'),
    url(r'^logs/section/(?P<pk>\d+)/update$', views.ViewLogSectionUpdate.as_view(), name='ViewLogSectionUpdate'),
    path('logs/settings/', views.ViewLogSettings.as_view(), name='ViewLogSettings'),

    # cache
    url(r'^cache/memory$', views.ViewCacheMemory.as_view(), name='ViewCacheMemory'),
    url(r'^cache/disk$', views.ViewCacheDisk.as_view(), name='ViewCacheDisk'),
    url(r'^cache/disk/enable/$', views.ViewCacheDiskEnable.as_view(), name='ViewCacheDiskEnable'),
    url(r'^cache/disk/reset/$', views.ViewCacheDiskReset.as_view(), name='ViewCacheDiskReset'),
    url(r'^cache/refresh/pattern/list$', views.ViewCacheRefreshPatternList.as_view(), name='ViewCacheRefreshPatternList'),
    url(r'^cache/refresh/pattern/create$', views.ViewCacheRefreshPatternCreate.as_view(), name='ViewCacheRefreshPatternCreate'),
    url(r'^cache/refresh/pattern/(?P<pk>\d+)/update$', views.ViewCacheRefreshPatternUpdate.as_view(), name='ViewCacheRefreshPatternUpdate'),
]