#
#
#
from django import forms
from django.views import generic
from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse

#
#
#
from squid.models import Dns

#
#
#

class DnsForm(forms.ModelForm):

    class Meta:
        model  = Dns
        fields = ['dns_timeout', 'dns_nameservers', 'dns_v4_first', 'append_domain']

    def clean_append_domain(self):

        value = self.cleaned_data['append_domain']
        value = value.strip()

        # we allow empty values just fine
        if len(value) == 0:
            return value

        # but if it is not empty, it must be correct
        if not value.startswith("."):
            raise forms.ValidationError("Domain name to append must start with . (dot).")
        if len(value) < 2:
            raise forms.ValidationError("Domain name to append must be longer that 1 character")

        return value

class ViewDns(SuccessMessageMixin, generic.edit.UpdateView):

    model           = Dns
    form_class      = DnsForm 
    template_name   = 'squid/settings/dns.html'
    success_message = 'need_squid_restart'

    def get_object(self):
        return Dns.objects.first()
    
    def get_success_url(self): 
        return reverse('squid:ViewDns')