# Generated by Django 3.1.7 on 2021-02-25 08:45

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Mailer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('smtp_username', models.CharField(blank=True, max_length=254)),
                ('smtp_password', models.CharField(blank=True, max_length=254)),
                ('smtp_server', models.CharField(blank=True, max_length=254)),
                ('smtp_port', models.IntegerField(default=587)),
                ('smtp_use_auth', models.BooleanField(default=True)),
                ('smtp_test_email', models.CharField(blank=True, max_length=254)),
            ],
        ),
        migrations.CreateModel(
            name='PeriodicReport',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=254, unique=True)),
                ('comments', models.TextField(blank=True)),
                ('enabled', models.BooleanField(default=True)),
                ('rep_type', models.CharField(choices=[('top_sites_by_size', 'Top Sites By Size'), ('top_sites_by_hits', 'Top Sites By Hits'), ('blocked_sites', 'Blocked Sites'), ('offensive_sites', 'Offensive Sites'), ('top_users_by_size', 'Top Users By Size'), ('top_users_by_hits', 'Top Users By Hits'), ('blocked_users', 'Blocked Users'), ('offensive_users', 'Offensive Users'), ('search_queries', 'Search Queries'), ('youtube_videos', 'Youtube Videos'), ('detected_categories', 'Detected Categories'), ('triggered_policies', 'Triggered Policies')], default='top_users_by_size', max_length=255)),
                ('schedule_min', models.CharField(default='*', max_length=64)),
                ('schedule_hour', models.CharField(default='*', max_length=64)),
                ('schedule_dom', models.CharField(default='*', max_length=64)),
                ('schedule_month', models.CharField(default='*', max_length=64)),
                ('schedule_dow', models.CharField(default='*', max_length=64)),
                ('timeframe_type', models.CharField(choices=[('last_n_days', 'Last N days'), ('last_n_weeks', 'Last N weeks'), ('last_n_months', 'Last N months'), ('from_to', 'Specific date interval')], default='last_n_days', max_length=64)),
                ('timeframe_value', models.IntegerField(default=7)),
                ('timeframe_from', models.DateField(blank=True, null=True)),
                ('timeframe_to', models.DateField(blank=True, null=True)),
                ('include_current', models.BooleanField(default=True)),
                ('include_domains', models.TextField(blank=True)),
                ('include_users', models.TextField(blank=True)),
                ('include_policies', models.TextField(blank=True)),
                ('exclude_domains', models.TextField(blank=True)),
                ('exclude_users', models.TextField(blank=True)),
                ('exclude_policies', models.TextField(blank=True)),
                ('limit_n_entries', models.IntegerField(default=50)),
                ('limit_n_drilldown', models.IntegerField(default=50)),
                ('send_to_emails', models.TextField(blank=True)),
            ],
        ),
        migrations.CreateModel(
            name='Traffic',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('realtime_regeneration_interval', models.IntegerField(default=60)),
                ('realtime_last_line_count', models.IntegerField(default=1000)),
                ('collector_enable', models.BooleanField(default=True)),
                ('collector_ignore_status_non_aborted', models.BooleanField(default=True)),
                ('collector_ignore_status_407', models.BooleanField(default=True)),
                ('collector_ignore_error_invalid_request', models.BooleanField(default=True)),
                ('collector_ignore_error_transaction_end', models.BooleanField(default=True)),
                ('collector_ignore_module_ads', models.BooleanField(default=True)),
                ('collector_ignore_module_privacy', models.BooleanField(default=True)),
                ('collector_ignore_module_sslbump', models.BooleanField(default=True)),
                ('collector_ignore_module_clean', models.BooleanField(default=False)),
                ('collector_ignore_module_adult_heuristics', models.BooleanField(default=False)),
                ('collector_ignore_module_adult_safesearch', models.BooleanField(default=True)),
                ('collector_ignore_module_adult_youtube', models.BooleanField(default=True)),
                ('collector_ignore_module_adult_phrases', models.BooleanField(default=False)),
                ('collector_ignore_module_adult_image', models.BooleanField(default=True)),
                ('collector_ignore_module_apps', models.BooleanField(default=True)),
                ('collector_folders', models.TextField(blank=True)),
                ('collector_cluster', models.BooleanField(default=True)),
                ('reporter_max_detailed_users', models.IntegerField(default=50)),
                ('reporter_max_detailed_domains', models.IntegerField(default=100)),
            ],
        ),
    ]
