#
# django
#
from django.conf.urls import url
from django.urls      import path

#
# our
#
from traffic import views


urlpatterns = [

    # templates
    #url(r'^templates/list/$', views.ViewReportTemplates.as_view(), name='ViewReportTemplates'),        
    
    # report exporter
    #url(r'^jobs/(?P<name>[\w\- ]+)/exportpdf/$', views.ViewReportExportPdf.as_view(), name='ViewReportExportPdf'),

    #url(r'^monitor/update/globals/$', views.View_MonitoringUpdateGlobals.as_view(), name='View_MonitoringUpdateGlobals'),    
    #url(r'^monitor/update/channels/$', views.View_MonitoringUpdateChannels.as_view(), name='View_MonitoringUpdateChannels'),    
    #url(r'^monitor/update/smtpconnector/$', views.View_MonitoringUpdateSmtpConnector.as_view(), name='View_MonitoringUpdateSmtpConnector'),    
    #url(r'^monitor/update/advanced/$', views.View_MonitoringUpdateAdvanced.as_view(), name='View_MonitoringUpdateAdvanced'),    
    #url(r'^monitor/monitor_log/$', views.View_MonitorUploadLog.as_view(), name='View_MonitorUploadLog'),

    #
    # periodic reports
    #
    path('periodic/reports/list/',   views.ViewPeriodicReports.as_view(), name="ViewPeriodicReports"),
    path('periodic/reports/create/', views.ViewPeriodicReportCreate.as_view(), name="ViewPeriodicReportCreate"),
    path('periodic/reports/<int:pk>/update/', views.ViewPeriodicReportUpdate.as_view(), name="ViewPeriodicReportUpdate"),
    path('periodic/reports/<int:pk>/view/<file>/', views.ViewPeriodicReportView.as_view(), name='ViewPeriodicReportView'),
    path('periodic/reports/<int:pk>/log/',         views.ViewPeriodicLog.as_view(), name='ViewPeriodicLog'),

    #url(r'^jobs/create/(?P<template>[\w\-]+)/$', views.ViewReportCreateJob.as_view(), name='ViewReportCreateJob'),        
    #url(r'^jobs/(?P<pk>\d+)/(?P<template>[\w\-]+)/edit/$', views.ViewReportUpdateJob.as_view(), name='ViewReportUpdateJob'),        
    #url(r'^jobs/(?P<pk>\d+)/generate/$', views.ViewReportGenerateJob.as_view(), name='ViewReportGenerateJob'),


    #
    # settings
    #    
    path('settings/realtime/',  views.ViewSettingsRealTime.as_view(), name='ViewSettingsRealTime'),    
    path('settings/collector/', views.ViewSettingsCollector.as_view(), name='ViewSettingsCollector'),    
    path('settings/mailer/',    views.ViewSettingsMailer.as_view(), name='ViewSettingsMailer'),    
    path('settings/mailer/test/', views.ViewSettingsMailerTest.as_view(), name='ViewSettingsMailerTest'),    

    #
    # logs
    #
    path('logs/cron_report_log/', views.ViewCronReportLog.as_view(), name='ViewCronReportLog'),    
    path('logs/realtime_report_log/', views.ViewRealTimeReportLog.as_view(), name='ViewRealTimeReportLog'),    
    
    #
    # history
    #
    path(
        'statistics/',   
            views.ViewStatistics.as_view(template_name = "traffic/reporter/statistics.html"),
                name='ViewStatistics'
    ),    
    path(
        'months/', 
            views.ViewMonths.as_view(template_name = "traffic/reporter/monthly/list.html"), 
                name='ViewMonths'
    ),    
    path(
        'years/',  
            views.ViewYears.as_view(template_name = "traffic/reporter/yearly/list.html"),  
                name='ViewYears'
    ),

    # summary page - for days, months and years
    path(
        'summary/now/',
            views.ViewSummary.as_view(template_name = "traffic/reporter/now/summary.html"), 
                kwargs = { "period":"now" }, 
                name   = 'ViewSummaryNow'
    ),
    path(
        'summary/<int:year>/<int:month>/<int:day>/', 
            views.ViewSummary.as_view(template_name = "traffic/reporter/daily/summary.html"), 
                kwargs = { "period":"day" }, 
                name   = 'ViewSummaryDaily'
    ),
    path(
        'summary/<int:year>/<int:month>/',
            views.ViewSummary.as_view(template_name = "traffic/reporter/monthly/summary.html"), 
                kwargs = { "period":"month" }, 
                name   = 'ViewSummaryMonthly'
    ),
    path(
        'summary/<int:year>/',
            views.ViewSummary.as_view(template_name = "traffic/reporter/yearly/summary.html"), 
                kwargs = { "period":"year" },
                name   = 'ViewSummaryYearly'
    ),

    #
    # DAILY VIEWS
    #

    #
    # users
    #
    path(
        'names/all/<int:year>/<int:month>/<int:day>/', 
            views.ViewUsers.as_view(template_name = "traffic/reporter/daily/names/list.html"), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewUsersDaily"
    ),
    path(
        'names/<requestor>/summary/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorSummary.as_view(template_name = "traffic/reporter/daily/names/name/summary.html"), 
                kwargs = {
                    "period"         : "day", 
                    "requestor_type" : "user_id"                    
                }, 
                name = "ViewNameSummaryDaily"
    ),    
    path(
        'names/<requestor>/activity/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorActivity.as_view(template_name = "traffic/reporter/daily/names/name/activity.html"), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewNameActivityDaily"
    ),
    path(
        'names/<requestor>/activity/<int:year>/<int:month>/<int:day>/download/',
            views.ViewRequestorActivityDownload.as_view(), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewNameActivityDailyDownload"
    ),
    path(
        'names/<requestor>/all/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/daily/names/name/domains_all.html"), 
                kwargs = {
                    "period"         : "day", 
                    "requestor_type" : "user_id", 
                    "show"           : "all"
                }, 
                name = "ViewNameAllDaily"
    ),
    path(
        'names/<requestor>/blocked/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/daily/names/name/domains_blocked.html"), 
                kwargs = {
                    "period"         : "day", 
                    "requestor_type" : "user_id", 
                    "show"           : "blocked"
                }, 
                name = "ViewNameBlockedDaily"
    ),
    path(
        'names/<requestor>/offensive/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/daily/names/name/domains_offensive.html"), 
                kwargs = {
                    "period"         : "day", 
                    "requestor_type" : "user_id", 
                    "show"           : "offensive"
                }, 
                name = "ViewNameOffensiveDaily"
    ),
    path(
        'names/<requestor>/time_of_day/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorTimeOfDay.as_view(template_name = "traffic/reporter/daily/names/name/domains_time_of_day.html"), 
                kwargs = {
                    "period"         : "day",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameTimeOfDayDaily"
    ),
    path(
        'names/<requestor>/videos/<int:year>/<int:month>/<int:day>/',
            views.ViewRequestorVideos.as_view(template_name = "traffic/reporter/daily/names/name/videos.html"), 
                kwargs = {
                    "period"         : "day",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameVideosDaily"
    ),

    #
    # domains
    #
    path(   
        'domains/all/<int:year>/<int:month>/<int:day>/',
            views.ViewDomains.as_view(template_name = "traffic/reporter/daily/domains/list.html"), 
                kwargs = { 
                    "period" : "day"
                }, 
                name = "ViewDomainsDaily"
    ),    
    path(
        'domain/<domain>/summary/<int:year>/<int:month>/<int:day>/',
            views.ViewDomainSummary.as_view(template_name = "traffic/reporter/daily/domains/domain/summary.html"), 
                kwargs = {
                    "period" : "day"                     
                }, 
                name = "ViewDomainSummaryDaily"
    ),
    path(
        'domain/<domain>/users/<int:year>/<int:month>/<int:day>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/daily/domains/domain/users.html"), 
                kwargs = { 
                    "period"         : "day",
                    "requestor_type" : "user_id"
                }, 
                name = "ViewDomainUsersDaily"
    ),
    path(
        'domain/<domain>/activity/<int:year>/<int:month>/<int:day>/',
            views.ViewDomainActivity.as_view(template_name = "traffic/reporter/daily/domains/domain/activity.html"), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewDomainActivityDaily"
    ),    
    path(
        'domain/<domain>/activity/<int:year>/<int:month>/<int:day>/download/',
            views.ViewDomainActivityDownload.as_view(), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewDomainActivityDailyDownload"
    ),    
    path(
        'domain/<domain>/time_of_day/<int:year>/<int:month>/<int:day>/',
            views.ViewDomainTimeOfDay.as_view(template_name = "traffic/reporter/daily/domains/domain/time_of_day.html"), 
                kwargs = {
                    "period" : "day"
                }, 
                name = "ViewDomainTimeOfDayDaily"
    ),

    #
    # REALTIME VIEWS
    #
    path('activity/now/', views.ViewActivityNow.as_view(), name = "ViewActivityNow"),

    #
    # users
    #
    path(
        'names/all/now/', 
            views.ViewUsers.as_view(template_name = "traffic/reporter/now/names/list.html"), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewUsersNow"
    ),
    path(
        'names/<requestor>/summary/now/',
            views.ViewRequestorSummary.as_view(template_name = "traffic/reporter/now/names/name/summary.html"), 
                kwargs = {
                    "period"         : "now", 
                    "requestor_type" : "user_id"                    
                }, 
                name = "ViewNameSummaryNow"
    ),    
    path(
        'names/<requestor>/activity/now/',
            views.ViewRequestorActivity.as_view(template_name = "traffic/reporter/now/names/name/activity.html"), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewNameActivityNow"
    ),
    path(
        'names/<requestor>/activity/now/download/',
            views.ViewRequestorActivityDownload.as_view(), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewNameActivityNowDownload"
    ),
    path(
        'names/<requestor>/all/now/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/now/names/name/domains_all.html"), 
                kwargs = {
                    "period"         : "now", 
                    "requestor_type" : "user_id", 
                    "show"           : "all"
                }, 
                name = "ViewNameAllNow"
    ),
    path(
        'names/<requestor>/blocked/now/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/now/names/name/domains_blocked.html"), 
                kwargs = {
                    "period"         : "now", 
                    "requestor_type" : "user_id", 
                    "show"           : "blocked"
                }, 
                name = "ViewNameBlockedNow"
    ),
    path(
        'names/<requestor>/offensive/now/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/now/names/name/domains_offensive.html"), 
                kwargs = {
                    "period"         : "now", 
                    "requestor_type" : "user_id", 
                    "show"           : "offensive"
                }, 
                name = "ViewNameOffensiveNow"
    ),
    path(
        'names/<requestor>/time_of_day/now/',
            views.ViewRequestorTimeOfDay.as_view(template_name = "traffic/reporter/now/names/name/domains_time_of_day.html"), 
                kwargs = {
                    "period"         : "now",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameTimeOfDayNow"
    ),
    path(
        'names/<requestor>/videos/now/',
            views.ViewRequestorVideos.as_view(template_name = "traffic/reporter/now/names/name/videos.html"), 
                kwargs = {
                    "period"         : "now",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameVideosNow"
    ),

    #
    # domains
    #
    path(   
        'domains/all/now/',
            views.ViewDomains.as_view(template_name = "traffic/reporter/now/domains/list.html"), 
                kwargs = { 
                    "period" : "now"
                }, 
                name = "ViewDomainsNow"
    ),    
    path(
        'domain/<domain>/summary/now/',
            views.ViewDomainSummary.as_view(template_name = "traffic/reporter/now/domains/domain/summary.html"), 
                kwargs = {
                    "period" : "now"                     
                }, 
                name = "ViewDomainSummaryNow"
    ),
    path(
        'domain/<domain>/users/now/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/now/domains/domain/users.html"), 
                kwargs = { 
                    "period"         : "now",
                    "requestor_type" : "user_id"
                }, 
                name = "ViewDomainUsersNow"
    ),
    path(
        'domain/<domain>/ips/now/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/now/domains/domain/ips.html"), 
                kwargs = {
                    "period"         : "now", 
                    "requestor_type" : "requestor_ip"
                }, 
                name = "ViewDomainIpsNow"
    ),
    path(
        'domain/<domain>/macs/now/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/now/domains/domain/macs.html"), 
                kwargs = { 
                    "period"         : "now", 
                    "requestor_type" : "requestor_mac"
                }, 
                name = "ViewDomainMacsNow"
    ),
    path(
        'domain/<domain>/activity/now/',
            views.ViewDomainActivity.as_view(template_name = "traffic/reporter/now/domains/domain/activity.html"), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewDomainActivityNow"
    ),    
    path(
        'domain/<domain>/activity/now/download/',
            views.ViewDomainActivityDownload.as_view(), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewDomainActivityNowDownload"
    ),    
    path(
        'domain/<domain>/time_of_day/now/',
            views.ViewDomainTimeOfDay.as_view(template_name = "traffic/reporter/now/domains/domain/time_of_day.html"), 
                kwargs = {
                    "period" : "now"
                }, 
                name = "ViewDomainTimeOfDayNow"
    ),

    #
    # MONTHLY VIEWS
    #

    #
    # users
    #
    path(
        'names/all/<int:year>/<int:month>/', 
            views.ViewUsers.as_view(template_name = "traffic/reporter/monthly/names/list.html"), 
                kwargs = {
                    "period" : "month"
                }, 
                name = "ViewUsersMonthly"
    ),
    path(
        'names/<requestor>/summary/<int:year>/<int:month>/',
            views.ViewRequestorSummary.as_view(template_name = "traffic/reporter/monthly/names/name/summary.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "user_id"                    
                }, 
                name = "ViewNameSummaryMonthly"
    ),    
    path(
        'names/<requestor>/activity/<int:year>/<int:month>/',
            views.ViewRequestorActivity.as_view(template_name = "traffic/reporter/monthly/names/name/activity.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "user_id"
                }, 
                name = "ViewNameActivityMonthly"
    ),
    path(
        'names/<requestor>/all/<int:year>/<int:month>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/monthly/names/name/domains_all.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "user_id", 
                    "show"           : "all"
                }, 
                name = "ViewNameAllMonthly"
    ),
    path(
        'names/<requestor>/blocked/<int:year>/<int:month>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/monthly/names/name/domains_blocked.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "user_id", 
                    "show"           : "blocked"
                }, 
                name = "ViewNameBlockedMonthly"
    ),
    path(
        'names/<requestor>/offensive/<int:year>/<int:month>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/monthly/names/name/domains_offensive.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "user_id", 
                    "show"           : "offensive"
                }, 
                name = "ViewNameOffensiveMonthly"
    ),
    path(
        'names/<requestor>/time_of_day/<int:year>/<int:month>/',
            views.ViewRequestorTimeOfDay.as_view(template_name = "traffic/reporter/monthly/names/name/domains_time_of_day.html"), 
                kwargs = {
                    "period"         : "month",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameTimeOfDayMonthly"
    ),

    #
    # domains
    #
    path(   
        'domains/all/<int:year>/<int:month>/',
            views.ViewDomains.as_view(template_name = "traffic/reporter/monthly/domains/list.html"), 
                kwargs = { 
                    "period" : "month"
                }, 
                name = "ViewDomainsMonthly"
    ),    
    path(
        'domain/<domain>/summary/<int:year>/<int:month>/',
            views.ViewDomainSummary.as_view(template_name = "traffic/reporter/monthly/domains/domain/summary.html"), 
                kwargs = {
                    "period" : "month"                     
                }, 
                name = "ViewDomainSummaryMonthly"
    ),
    path(
        'domain/<domain>/users/<int:year>/<int:month>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/monthly/domains/domain/users.html"), 
                kwargs = { 
                    "period"         : "month",
                    "requestor_type" : "user_id"
                }, 
                name = "ViewDomainUsersMonthly"
    ),
    path(
        'domain/<domain>/ips/<int:year>/<int:month>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/monthly/domains/domain/ips.html"), 
                kwargs = {
                    "period"         : "month", 
                    "requestor_type" : "requestor_ip"
                }, 
                name = "ViewDomainIpsMonthly"
    ),
    path(
        'domain/<domain>/macs/<int:year>/<int:month>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/monthly/domains/domain/macs.html"), 
                kwargs = { 
                    "period"         : "month", 
                    "requestor_type" : "requestor_mac"
                }, 
                name = "ViewDomainMacsMonthly"
    ),
    path(
        'domain/<domain>/activity/<int:year>/<int:month>/',
            views.ViewDomainActivity.as_view(template_name = "traffic/reporter/monthly/domains/domain/activity.html"), 
                kwargs = {
                    "period" : "month"
                }, 
                name = "ViewDomainActivityMonthly"
    ),    
    path(
        'domain/<domain>/time_of_day/<int:year>/<int:month>/',
            views.ViewDomainTimeOfDay.as_view(template_name = "traffic/reporter/monthly/domains/domain/time_of_day.html"), 
                kwargs = {
                    "period" : "month"
                }, 
                name = "ViewDomainTimeOfDayMonthly"
    ),

    #
    # YEARLY VIEWS
    #

    #
    # users
    #
    path(
        'names/all/<int:year>/', 
            views.ViewUsers.as_view(template_name = "traffic/reporter/yearly/names/list.html"), 
                kwargs = {
                    "period" : "year"
                }, 
                name = "ViewUsersYearly"
    ),
    path(
        'names/<requestor>/summary/<int:year>/',
            views.ViewRequestorSummary.as_view(template_name = "traffic/reporter/yearly/names/name/summary.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "user_id"                    
                }, 
                name = "ViewNameSummaryYearly"
    ),    
    path(
        'names/<requestor>/activity/<int:year>/',
            views.ViewRequestorActivity.as_view(template_name = "traffic/reporter/yearly/names/name/activity.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "user_id"
                }, 
                name = "ViewNameActivityYearly"
    ),
    path(
        'names/<requestor>/all/<int:year>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/yearly/names/name/domains_all.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "user_id", 
                    "show"           : "all"
                }, 
                name = "ViewNameAllYearly"
    ),
    path(
        'names/<requestor>/blocked/<int:year>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/yearly/names/name/domains_blocked.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "user_id", 
                    "show"           : "blocked"
                }, 
                name = "ViewNameBlockedYearly"
    ),
    path(
        'names/<requestor>/offensive/<int:year>/',
            views.ViewRequestorDomains.as_view(template_name = "traffic/reporter/yearly/names/name/domains_offensive.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "user_id", 
                    "show"           : "offensive"
                }, 
                name = "ViewNameOffensiveYearly"
    ),
    path(
        'names/<requestor>/time_of_day/<int:year>/',
            views.ViewRequestorTimeOfDay.as_view(template_name = "traffic/reporter/yearly/names/name/domains_time_of_day.html"), 
                kwargs = {
                    "period"         : "year",
                    "requestor_type" : "user_id", 
                }, 
                name = "ViewNameTimeOfDayYearly"
    ),

    #
    # domains
    #
    path(   
        'domains/all/<int:year>/',
            views.ViewDomains.as_view(template_name = "traffic/reporter/yearly/domains/list.html"), 
                kwargs = { 
                    "period" : "year"
                }, 
                name = "ViewDomainsYearly"
    ),    
    path(
        'domain/<domain>/summary/<int:year>/',
            views.ViewDomainSummary.as_view(template_name = "traffic/reporter/yearly/domains/domain/summary.html"), 
                kwargs = {
                    "period" : "year"                     
                }, 
                name = "ViewDomainSummaryYearly"
    ),
    path(
        'domain/<domain>/users/<int:year>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/yearly/domains/domain/users.html"), 
                kwargs = { 
                    "period"         : "year",
                    "requestor_type" : "user_id"
                }, 
                name = "ViewDomainUsersYearly"
    ),
    path(
        'domain/<domain>/ips/<int:year>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/yearly/domains/domain/ips.html"), 
                kwargs = {
                    "period"         : "year", 
                    "requestor_type" : "requestor_ip"
                }, 
                name = "ViewDomainIpsYearly"
    ),
    path(
        'domain/<domain>/macs/<int:year>/',
            views.ViewDomainRequestors.as_view(template_name = "traffic/reporter/yearly/domains/domain/macs.html"), 
                kwargs = { 
                    "period"         : "year", 
                    "requestor_type" : "requestor_mac"
                }, 
                name = "ViewDomainMacsYearly"
    ),
    path(
        'domain/<domain>/activity/<int:year>/',
            views.ViewDomainActivity.as_view(template_name = "traffic/reporter/yearly/domains/domain/activity.html"), 
                kwargs = {
                    "period" : "year"
                }, 
                name = "ViewDomainActivityYearly"
    ),    
    path(
        'domain/<domain>/time_of_day/<int:year>/',
            views.ViewDomainTimeOfDay.as_view(template_name = "traffic/reporter/yearly/domains/domain/time_of_day.html"), 
                kwargs = {
                    "period" : "year"
                }, 
                name = "ViewDomainTimeOfDayYearly"
    ),
]
