import os
import traceback

#
# django
#
from django.views import generic

#
# domain
#
#from _domain.traffic.report import DomainsReporter, RequestType

#
# local
#
from .mixins import *

#
#
#
class ViewDomainRequestor(ReporterMixin, generic.TemplateView):

    def get_context_data(self, **kwargs):

        # get the context
        context = super(ViewDomainRequestor, self).get_context_data(**kwargs)

        try:

            # create reporter
            r = DomainsReporter(self.get_dataframe(), RequestType.All)

            # get reporter for specific domain
            d = r.specific(
                self.kwargs['domain']
            )

            # get label, ip or mac reporter from it
            r1 = None
            if True:

                t = self.kwargs['requestor_type']
                if t == "requestor_name":
                    r1 = d.labels()
                elif t == "requestor_ip":
                    r1 = d.ips()
                elif t == "requestor_mac":
                    r1 =d.macs()
                else:
                    raise Exception("Unknown requestor_type == %s" % t)

            # now get specific requestor
            r2 = r1.specific(
                self.kwargs['requestor']
            )

            # and fill the context
            context['object_list'] = r2.all()
            context['summary']     = r2.summary()

        except Exception as e:

            context['error_text'] = str(e)
            context['traceback']  = str(traceback.format_exc())

        return context
