import os
import traceback

#
# django
#
from django.views import generic

#
# domain
#
#from _domain.traffic.report import DomainsReporter, RequestType

#
# local
#
from .mixins import *

#
#
#
class ViewDomainRequestors(ReporterMixin, generic.TemplateView):

    def get_context_data(self, **kwargs):

        # get the context
        context = super(ViewDomainRequestors, self).get_context_data(**kwargs)

        try:

            # the domain we are displaying
            entry = self.kwargs['domain']
            
            # create loader for a given entry
            l = DomainLoader(self.get_period(), entry)

            # load info for a given requestor            
            (dataframe, totals) = l.requestors(
                self.kwargs['requestor_type']
            )

            # and fill the context
            context['object_list'] = dataframe
            context['totals']      = totals

        except Exception as e:

            context['error_text'] = str(e)
            context['traceback']  = str(traceback.format_exc())

        return context
