import os
import traceback

#
# django
#
from django.views import generic

#
# domain
#
#from _domain.traffic.report import RequestType

#
# local
#
from .mixins import *

#
#
#
class ViewRequestorDomain(RequestorMixin, ReporterMixin, generic.TemplateView):

    def get_context_data(self, **kwargs):

        # get the context
        context = super(ViewRequestorDomain, self).get_context_data(**kwargs)

        try:

            # the label/ip/mac or domain we are displaying
            requestor = self.kwargs['requestor']
            domain    = self.kwargs['domain']

            # create loader for a given entry
            C = self.get_loader_class()
            l = C(self.get_period(), requestor)

            # load activity file
            a = l.activity(domain)

            # and fill the context
            context['object_list'] = a
            #context['summary']     = d.summary()

        except Exception as e:

            context['error_text'] = str(e)
            context['traceback']  = str(traceback.format_exc())

        return context
