import os
import traceback

#
# django
#
from django.views import generic

#
# domain
#
#from _domain.traffic.report import RequestType

#
# local
#
from .mixins import *

#
#
#
class ViewRequestorDomains(RequestorMixin, ReporterMixin, generic.TemplateView):

    def get_context_data(self, **kwargs):

        # get the context
        context = super(ViewRequestorDomains, self).get_context_data(**kwargs)

        try:

            # the label/ip/mac or domain we are displaying
            entry = self.kwargs['requestor']

            # create loader for a given entry
            C = self.get_loader_class()
            l = C(self.get_period(), entry)

            # see what we have to show            
            show = self.kwargs['show']

            # ask the loader
            (dataframe, totals) = l.domains(show)

            # and fill the context
            context['totals']      = totals
            context['object_list'] = dataframe

        except Exception as e:

            context['error_text'] = str(e)
            context['traceback']  = str(traceback.format_exc())

        return context
