from django.shortcuts import render
from django.views     import generic

#
# 
#
class ListViewTransposer:
    
    def transpose(self, list, columns):
    
        # debug check 
        assert(columns)  > 1
        
        table = []
        if columns > len(list):
            table.append(list)
            return table
        
        # create number of columns requred
        for i in xrange(0, columns):
             table.append([])
             
        if len(list) == 0:
            return table
        
        # see how many elements will fit into each column
        num = len(list) / columns + len(list) % columns
        
        # polulate the table
        for i in xrange(0, columns):
            for j in xrange(0, num):
                table[i].append(list.pop(0))
                if len(list) == 0:
                    break
            if len(list) == 0:
                    break
                    
        # transpose it
        table = map(None,*table)
        
        # and return        
        return table

#
# 
#
class ViewBaseLog(generic.base.TemplateView):

    def get_context_data(self, **kwargs):

        context = super(ViewBaseLog, self).get_context_data(**kwargs)        

        # get size, include and exclude strings from request
        include = self.request.GET.get('include', '')
        exclude = self.request.GET.get('exclude', '')
        size    = 256
        try:
            size = int(self.request.GET.get('size', '256'))
            if size > 1024:
                size = 1024
        except Exception as e:
            pass

        # save into context
        context['size']         = size
        context['include']      = include
        context['exclude']      = exclude
        context['log_contents'] = self.get_contents(size, include, exclude)
        context['log_size']     = self.get_size()
        context['log_path']     = self.log_class().get_path()

        return context

    def get_size(self):

        log  = self.log_class()
        size = log.get_size()
       
        return size

    def get_contents(self, line_count, include, exclude):

        log      = self.log_class()
        contents = log.get_contents(line_count, include, exclude)
        if not contents:
            contents = "Requested log file is empty."
        
        return contents